define("discourse/plugins/poll/discourse/components/modal/poll-breakdown",["exports","@ember/component","@ember/object","@ember/service","@ember/string","@ember/template","discourse/lib/ajax","discourse/lib/ajax-error","discourse/lib/load-script","discourse-common/utils/decorators","discourse-i18n","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p,d){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
const c=(0,d.createTemplateFactory)({id:"YRvkhP/Q",block:'[[[8,[39,0],[[24,0,"poll-breakdown has-tabs"]],[["@title","@closeModal"],[[28,[37,1],["poll.breakdown.title"],null],[30,1]]],[["headerBelowTitle","body"],[[[[1,"\\n    "],[10,"ul"],[14,0,"modal-tabs"],[12],[1,"\\n      "],[11,"li"],[16,0,[28,[37,2],["modal-tab percentage",[52,[28,[37,4],[[30,0,["displayMode"]],"percentage"],null],"is-active"]],null]],[4,[38,5],["click",[28,[37,6],[[28,[37,7],[[30,0,["displayMode"]]],null],"percentage"],null]],null],[12],[1,[28,[35,1],["poll.breakdown.percentage"],null]],[13],[1,"\\n      "],[11,"li"],[16,0,[28,[37,2],["modal-tab count",[52,[28,[37,4],[[30,0,["displayMode"]],"count"],null],"is-active"]],null]],[4,[38,5],["click",[28,[37,6],[[28,[37,7],[[30,0,["displayMode"]]],null],"count"],null]],null],[12],[1,[28,[35,1],["poll.breakdown.count"],null]],[13],[1,"\\n    "],[13],[1,"\\n  "]],[]],[[[1,"\\n    "],[10,0],[14,0,"poll-breakdown-sidebar"],[12],[1,"\\n      "],[10,2],[14,0,"poll-breakdown-title"],[12],[1,"\\n        "],[1,[30,0,["title"]]],[1,"\\n      "],[13],[1,"\\n\\n      "],[10,0],[14,0,"poll-breakdown-total-votes"],[12],[1,[28,[35,1],["poll.breakdown.votes"],[["count"],[[30,0,["model","poll","voters"]]]]]],[13],[1,"\\n\\n      "],[10,"ul"],[14,0,"poll-breakdown-options"],[12],[1,"\\n"],[42,[28,[37,9],[[28,[37,9],[[30,0,["model","poll","options"]]],null]],null],null,[[[1,"          "],[8,[39,10],null,[["@option","@index","@totalVotes","@optionsCount","@displayMode","@highlightedOption","@onMouseOver","@onMouseOut"],[[30,2],[30,3],[30,0,["totalVotes"]],[30,0,["model","poll","options","length"]],[30,0,["displayMode"]],[30,0,["highlightedOption"]],[28,[37,6],[[28,[37,7],[[30,0,["highlightedOption"]]],null],[30,3]],null],[28,[37,6],[[28,[37,7],[[30,0,["highlightedOption"]]],null],null],null]]],null],[1,"\\n"]],[2,3]],null],[1,"      "],[13],[1,"\\n    "],[13],[1,"\\n\\n    "],[10,0],[14,0,"poll-breakdown-body"],[12],[1,"\\n      "],[10,0],[14,0,"poll-breakdown-body-header"],[12],[1,"\\n        "],[10,"label"],[14,0,"poll-breakdown-body-header-label"],[12],[1,[28,[35,1],["poll.breakdown.breakdown"],null]],[13],[1,"\\n\\n        "],[8,[39,11],[[24,0,"poll-breakdown-dropdown"]],[["@content","@value","@nameProperty","@onChange"],[[30,0,["groupableUserFields"]],[30,0,["groupedBy"]],"label",[30,0,["setGrouping"]]]],null],[1,"\\n      "],[13],[1,"\\n\\n      "],[10,0],[14,0,"poll-breakdown-charts"],[12],[1,"\\n"],[42,[28,[37,9],[[28,[37,9],[[30,0,["charts"]]],null]],null],null,[[[1,"          "],[8,[39,12],null,[["@group","@options","@displayMode","@highlightedOption","@setHighlightedOption"],[[28,[37,13],[[30,4],"group"],null],[28,[37,13],[[30,4],"options"],null],[30,0,["displayMode"]],[30,0,["highlightedOption"]],[28,[37,6],[[28,[37,7],[[30,0,["highlightedOption"]]],null]],null]]],null],[1,"\\n"]],[4]],null],[1,"      "],[13],[1,"\\n    "],[13],[1,"\\n  "]],[]]]]]],["@closeModal","option","index","chart"],false,["d-modal","i18n","concat-class","if","eq","on","fn","mut","each","-track-array","poll-breakdown-option","combo-box","poll-breakdown-chart","get"]]',moduleName:"discourse/plugins/poll/discourse/components/modal/poll-breakdown.hbs",isStrictMode:!1})
class h extends e.default{static#t=(()=>dt7948.g(this.prototype,"dialog",[o.service]))()
#e=(()=>{dt7948.i(this,"dialog")})()
model=null
charts=null
groupedBy=null
highlightedOption=null
displayMode="percentage"
init(){this.set("groupedBy",this.model.groupableUserFields[0]),(0,a.default)("/javascripts/Chart.min.js").then((()=>(0,a.default)("/javascripts/chartjs-plugin-datalabels.min.js"))).then((()=>{this.fetchGroupedPollData()})),super.init(...arguments)}title(t,e){return t?(0,n.htmlSafe)(t):e}static#l=(()=>dt7948.n(this.prototype,"title",[(0,u.default)("model.poll.title","model.post.topic.title")]))()
groupableUserFields(t){return t.map((t=>{const e=t.split("_").filter(Boolean)
return e.length>1&&(e[0]=(0,s.classify)(e[0])),{id:t,label:e.join(" ")}}))}static#o=(()=>dt7948.n(this.prototype,"groupableUserFields",[(0,u.default)("model.groupableUserFields")]))()
totalVotes(t){return t.reduce(((t,e)=>t+e.votes),0)}static#s=(()=>dt7948.n(this.prototype,"totalVotes",[(0,u.default)("model.poll.options")]))()
fetchGroupedPollData(){return(0,i.ajax)("/polls/grouped_poll_results.json",{data:{post_id:this.model.post.id,poll_name:this.model.poll.name,user_field_name:this.groupedBy}}).catch((t=>{t?(0,r.popupAjaxError)(t):this.dialog.alert(p.default.t("poll.error_while_fetching_voters"))})).then((t=>{this.isDestroying||this.isDestroyed||this.set("charts",t.grouped_results)}))}setGrouping(t){this.set("groupedBy",t),this.fetchGroupedPollData()}static#n=(()=>dt7948.n(this.prototype,"setGrouping",[l.action]))()
onSelectPanel(t){this.set("displayMode",t.id)}static#i=(()=>dt7948.n(this.prototype,"onSelectPanel",[l.action]))()}t.default=h,(0,e.setComponentTemplate)(c,h)})),define("discourse/plugins/poll/discourse/components/modal/poll-ui-builder",["exports","@ember/component","@ember/object","@ember/object/computed","@ember/service","@ember-decorators/object","discourse-common/utils/decorators","discourse-i18n","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=t.REGULAR_POLL_TYPE=t.RANKED_CHOICE_POLL_TYPE=t.PIE_CHART_TYPE=t.NUMBER_POLL_TYPE=t.MULTIPLE_POLL_TYPE=t.BAR_CHART_TYPE=void 0
const u=(0,a.createTemplateFactory)({id:"e6ThmDt/",block:'[[[8,[39,0],[[24,0,"poll-ui-builder"]],[["@title","@closeModal","@inline"],[[28,[37,1],["poll.ui_builder.title"],null],[30,1],[30,2]]],[["body","footer"],[[[[1,"\\n    "],[10,"ul"],[14,0,"nav nav-pills poll-type"],[12],[1,"\\n      "],[10,"li"],[12],[1,"\\n        "],[8,[39,2],[[16,0,[28,[37,3],["poll-type-value poll-type-value-regular",[52,[30,0,["isRegular"]],"active"]],null]]],[["@action"],[[28,[37,5],[[30,0,["updatePollType"]],"regular"],null]]],[["default"],[[[[1,"\\n          "],[1,[28,[35,1],["poll.ui_builder.poll_type.regular"],null]],[1,"\\n        "]],[]]]]],[1,"\\n      "],[13],[1,"\\n      "],[10,"li"],[12],[1,"\\n        "],[8,[39,2],[[16,0,[28,[37,3],["poll-type-value poll-type-value-multiple",[52,[30,0,["isMultiple"]],"active"]],null]]],[["@action"],[[28,[37,5],[[30,0,["updatePollType"]],"multiple"],null]]],[["default"],[[[[1,"\\n          "],[1,[28,[35,1],["poll.ui_builder.poll_type.multiple"],null]],[1,"\\n        "]],[]]]]],[1,"\\n      "],[13],[1,"\\n"],[41,[30,0,["showNumber"]],[[[1,"        "],[10,"li"],[12],[1,"\\n          "],[8,[39,2],[[16,0,[28,[37,3],["poll-type-value poll-type-value-number",[52,[30,0,["isNumber"]],"active"]],null]]],[["@action"],[[28,[37,5],[[30,0,["updatePollType"]],"number"],null]]],[["default"],[[[[1,"\\n            "],[1,[28,[35,1],["poll.ui_builder.poll_type.number"],null]],[1,"\\n          "]],[]]]]],[1,"\\n        "],[13],[1,"\\n"]],[]],null],[41,[30,0,["showRankedChoice"]],[[[1,"        "],[10,"li"],[12],[1,"\\n          "],[8,[39,2],[[16,0,[28,[37,3],["poll-type-value poll-type-value-ranked-choice",[52,[30,0,["isRankedChoice"]],"active"]],null]]],[["@action"],[[28,[37,5],[[30,0,["updatePollType"]],"ranked_choice"],null]]],[["default"],[[[[1,"\\n            "],[1,[28,[35,1],["poll.ui_builder.poll_type.ranked_choice"],null]],[1,"\\n          "]],[]]]]],[1,"\\n        "],[13],[1,"\\n"]],[]],null],[1,"    "],[13],[1,"\\n\\n"],[41,[30,0,["showAdvanced"]],[[[1,"      "],[10,0],[14,0,"input-group poll-title"],[12],[1,"\\n        "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.poll_title.label"],null]],[13],[1,"\\n        "],[8,[39,6],null,[["@value"],[[30,0,["pollTitle"]]]],null],[1,"\\n      "],[13],[1,"\\n"]],[]],null],[1,"\\n"],[41,[51,[30,0,["isNumber"]]],[[[1,"      "],[10,0],[14,0,"poll-options"],[12],[1,"\\n"],[41,[30,0,["showAdvanced"]],[[[1,"          "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.poll_options.label"],null]],[13],[1,"\\n          "],[8,[39,8],[[4,[38,9],["input",[30,0,["onOptionsTextChange"]]],null]],[["@value"],[[30,0,["pollOptionsText"]]]],null],[1,""],[41,[30,0,["showMinNumOfOptionsValidation"]],[[[41,[51,[30,0,["minNumOfOptionsValidation","ok"]]],[[[1,"              "],[8,[39,10],null,[["@validation"],[[30,0,["minNumOfOptionsValidation"]]]],null],[1,"\\n"]],[]],null]],[]],null]],[]],[[[42,[28,[37,12],[[28,[37,12],[[30,0,["pollOptions"]]],null]],null],null,[[[1,"            "],[10,0],[14,0,"input-group poll-option-value"],[12],[1,"\\n              "],[11,"input"],[16,2,[30,3,["value"]]],[24,4,"text"],[4,[38,13],null,null],[4,[38,9],["input",[28,[37,5],[[30,0,["updateValue"]],[30,3]],null]],null],[4,[38,9],["keydown",[28,[37,5],[[30,0,["onInputKeydown"]],[30,4]],null]],null],[12],[13],[1,"\\n"],[41,[30,0,["canRemoveOption"]],[[[1,"                "],[8,[39,2],null,[["@icon","@action"],["trash-alt",[28,[37,5],[[30,0,["removeOption"]],[30,3]],null]]],null],[1,"\\n"]],[]],null],[1,"            "],[13],[1,"\\n"]],[3,4]],null],[1,"\\n          "],[10,0],[14,0,"poll-option-controls"],[12],[1,"\\n            "],[8,[39,2],[[24,0,"btn-default poll-option-add"]],[["@icon","@label","@action"],["plus","poll.ui_builder.poll_options.add",[28,[37,5],[[30,0,["addOption"]],-1],null]]],null],[1,"\\n"],[41,[28,[37,14],[[30,0,["showMinNumOfOptionsValidation"]],[28,[37,15],[[30,0,["minNumOfOptionsValidation","ok"]]],null]],null],[[[1,"              "],[8,[39,10],null,[["@validation"],[[30,0,["minNumOfOptionsValidation"]]]],null],[1,"\\n"]],[]],null],[1,"          "],[13],[1,"\\n"]],[]]],[1,"      "],[13],[1,"\\n"]],[]],null],[1,"\\n"],[41,[51,[30,0,["rankedChoiceOrRegular"]]],[[[1,"      "],[10,0],[14,0,"options"],[12],[1,"\\n        "],[10,0],[14,0,"input-group poll-number"],[12],[1,"\\n          "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.poll_config.min"],null]],[13],[1,"\\n          "],[8,[39,6],[[24,0,"poll-options-min"],[24,"min","1"]],[["@type","@value"],["number",[30,0,["pollMin"]]]],null],[1,"\\n        "],[13],[1,"\\n\\n        "],[10,0],[14,0,"input-group poll-number"],[12],[1,"\\n          "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.poll_config.max"],null]],[13],[1,"\\n          "],[8,[39,6],[[24,0,"poll-options-max"],[24,"min","1"]],[["@type","@value"],["number",[30,0,["pollMax"]]]],null],[1,"\\n        "],[13],[1,"\\n\\n"],[41,[30,0,["isNumber"]],[[[1,"          "],[10,0],[14,0,"input-group poll-number"],[12],[1,"\\n            "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.poll_config.step"],null]],[13],[1,"\\n            "],[8,[39,6],[[24,"min","1"],[24,0,"poll-options-step"]],[["@type","@value"],["number",[30,0,["pollStep"]]]],null],[1,"\\n          "],[13],[1,"\\n"]],[]],null],[1,"      "],[13],[1,"\\n\\n"],[41,[51,[30,0,["minMaxValueValidation","ok"]]],[[[1,"        "],[8,[39,10],null,[["@validation"],[[30,0,["minMaxValueValidation"]]]],null],[1,"\\n"]],[]],null]],[]],null],[1,"\\n    "],[10,0],[14,0,"input-group poll-public"],[12],[1,"\\n      "],[8,[39,16],[[24,0,"poll-toggle-public"],[4,[38,9],["click",[30,0,["togglePublic"]]],null]],[["@state","@label"],[[30,0,["publicPoll"]],"poll.ui_builder.poll_public.label"]],null],[1,"\\n    "],[13],[1,"\\n\\n"],[41,[30,0,["showAdvanced"]],[[[1,"      "],[10,0],[14,0,"input-group poll-allowed-groups"],[12],[1,"\\n        "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.poll_groups.label"],null]],[13],[1,"\\n        "],[8,[39,17],null,[["@content","@value","@onChange","@labelProperty","@valueProperty"],[[30,0,["siteGroups"]],[30,0,["pollGroups"]],[28,[37,5],[[28,[37,18],[[30,0,["pollGroups"]]],null]],null],"name","name"]],null],[1,"\\n      "],[13],[1,"\\n\\n      "],[10,0],[14,0,"input-group poll-date"],[12],[1,"\\n        "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.automatic_close.label"],null]],[13],[1,"\\n        "],[8,[39,19],null,[["@date","@onChange","@clearable","@useGlobalPickerContainer"],[[30,0,["pollAutoClose"]],[28,[37,5],[[28,[37,18],[[30,0,["pollAutoClose"]]],null]],null],true,true]],null],[1,"\\n      "],[13],[1,"\\n\\n      "],[10,0],[14,0,"input-group poll-select"],[12],[1,"\\n        "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.poll_result.label"],null]],[13],[1,"\\n        "],[8,[39,20],[[24,0,"poll-result"]],[["@content","@value","@valueProperty","@onChange"],[[30,0,["pollResults"]],[30,0,["pollResult"]],"value",[28,[37,5],[[28,[37,18],[[30,0,["pollResult"]]],null]],null]]],null],[1,"\\n      "],[13],[1,"\\n\\n"],[41,[51,[30,0,["rankedChoiceOrNumber"]]],[[[1,"        "],[10,0],[14,0,"input-group poll-select column"],[12],[1,"\\n          "],[10,"label"],[14,0,"input-group-label"],[12],[1,[28,[35,1],["poll.ui_builder.poll_chart_type.label"],null]],[13],[1,"\\n\\n          "],[10,0],[14,0,"radio-group"],[12],[1,"\\n            "],[8,[39,21],null,[["@id","@name","@value","@selection"],["poll-chart-type-bar","poll-chart-type","bar",[30,0,["chartType"]]]],null],[1,"\\n            "],[10,"label"],[14,"for","poll-chart-type-bar"],[12],[1,[28,[35,22],["chart-bar"],null]],[1,"\\n              "],[1,[28,[35,1],["poll.ui_builder.poll_chart_type.bar"],null]],[13],[1,"\\n          "],[13],[1,"\\n\\n          "],[10,0],[14,0,"radio-group"],[12],[1,"\\n            "],[8,[39,21],null,[["@id","@name","@value","@selection"],["poll-chart-type-pie","poll-chart-type","pie",[30,0,["chartType"]]]],null],[1,"\\n            "],[10,"label"],[14,"for","poll-chart-type-pie"],[12],[1,[28,[35,22],["chart-pie"],null]],[1,"\\n              "],[1,[28,[35,1],["poll.ui_builder.poll_chart_type.pie"],null]],[13],[1,"\\n          "],[13],[1,"\\n        "],[13],[1,"\\n"]],[]],null]],[]],null],[1,"  "]],[]],[[[1,"\\n    "],[8,[39,2],[[24,0,"btn-primary insert-poll"]],[["@action","@icon","@label","@disabled"],[[30,0,["insertPoll"]],"chart-bar","poll.ui_builder.insert",[30,0,["disableInsert"]]]],null],[1,"\\n\\n    "],[8,[39,2],[[24,0,"btn-flat"]],[["@label","@action"],["cancel",[30,1]]],null],[1,"\\n\\n    "],[8,[39,2],[[24,0,"btn-default show-advanced"]],[["@action","@icon","@title"],[[30,0,["toggleAdvanced"]],"cog",[52,[30,0,["showAdvanced"]],"poll.ui_builder.hide_advanced","poll.ui_builder.show_advanced"]]],null],[1,"\\n\\n  "]],[]]]]]],["@closeModal","@inline","option","index"],false,["d-modal","i18n","d-button","concatClass","if","fn","input","unless","textarea","on","input-tip","each","-track-array","auto-focus","and","not","d-toggle-switch","group-chooser","mut","date-time-input","combo-box","radio-button","d-icon"]]',moduleName:"discourse/plugins/poll/discourse/components/modal/poll-ui-builder.hbs",isStrictMode:!1}),p=t.BAR_CHART_TYPE="bar",d=t.PIE_CHART_TYPE="pie",c=t.REGULAR_POLL_TYPE="regular",h=t.NUMBER_POLL_TYPE="number",m=t.MULTIPLE_POLL_TYPE="multiple",g=t.RANKED_CHOICE_POLL_TYPE="ranked_choice",f="always"
class b extends e.default{static#t=(()=>dt7948.g(this.prototype,"siteSettings",[s.service]))()
#r=(()=>{dt7948.i(this,"siteSettings")})()
showAdvanced=!1
pollType=(()=>c)()
pollTitle
pollOptions=(()=>[l.default.create({value:""})])()
pollOptionsText=""
pollMin=1
pollMax=2
pollStep=1
pollGroups
pollAutoClose
pollResult=(()=>f)()
chartType=(()=>p)()
publicPoll=this.siteSettings.poll_default_public
static#l=(()=>dt7948.g(this.prototype,"showNumber",[(0,o.or)("showAdvanced","isNumber")]))()
#a=(()=>{dt7948.i(this,"showNumber")})()
static#o=(()=>dt7948.g(this.prototype,"showRankedChoice",[(0,o.or)("showAdvanced","isRankedChoice")]))()
#u=(()=>{dt7948.i(this,"showRankedChoice")})()
static#s=(()=>dt7948.g(this.prototype,"canRemoveOption",[(0,o.gt)("pollOptions.length",1)]))()
#p=(()=>{dt7948.i(this,"canRemoveOption")})()
static#n=(()=>dt7948.g(this.prototype,"rankedChoiceOrRegular",[(0,o.or)("isRankedChoice","isRegular")]))()
#d=(()=>{dt7948.i(this,"rankedChoiceOrRegular")})()
static#i=(()=>dt7948.g(this.prototype,"rankedChoiceOrNumber",[(0,o.or)("isRankedChoice","isNumber")]))()
#c=(()=>{dt7948.i(this,"rankedChoiceOrNumber")})()
pollResults(t){const e=[{name:r.default.t("poll.ui_builder.poll_result.always"),value:f},{name:r.default.t("poll.ui_builder.poll_result.vote"),value:"on_vote"},{name:r.default.t("poll.ui_builder.poll_result.closed"),value:"on_close"}]
return t&&e.push({name:r.default.t("poll.ui_builder.poll_result.staff"),value:"staff_only"}),e}static#h=(()=>dt7948.n(this.prototype,"pollResults",[(0,i.default)("currentUser.staff")]))()
isRegular(t){return t===c}static#m=(()=>dt7948.n(this.prototype,"isRegular",[(0,i.default)("pollType")]))()
isNumber(t){return t===h}static#g=(()=>dt7948.n(this.prototype,"isNumber",[(0,i.default)("pollType")]))()
isMultiple(t){return t===m}static#f=(()=>dt7948.n(this.prototype,"isMultiple",[(0,i.default)("pollType")]))()
isRankedChoice(t){return t===g}static#b=(()=>dt7948.n(this.prototype,"isRankedChoice",[(0,i.default)("pollType")]))()
pollOptionsCount(t){return(t||[]).filter((t=>t.value.length>0)).length}static#_=(()=>dt7948.n(this.prototype,"pollOptionsCount",[(0,i.default)("pollOptions.@each.value")]))()
siteGroups(t){return t.filter((t=>0!==t.id))}static#v=(()=>dt7948.n(this.prototype,"siteGroups",[(0,i.default)("site.groups")]))()
isPie(t,e){return e!==h&&t===d}static#y=(()=>dt7948.n(this.prototype,"isPie",[(0,i.default)("chartType","pollType")]))()
_setPollMinMax(){this.isMultiple?((this.pollMin<=0||this.pollMin>=this.pollMax||this.pollMin>=this.pollOptionsCount)&&this.set("pollMin",this.pollOptionsCount>0?1:0),(this.pollMax<=0||this.pollMin>=this.pollMax||this.pollMax>this.pollOptionsCount)&&this.set("pollMax",this.pollOptionsCount)):this.isNumber&&this.set("pollMax",this.siteSettings.poll_maximum_options)}static#k=(()=>dt7948.n(this.prototype,"_setPollMinMax",[(0,n.observes)("pollType","pollOptionsCount")]))()
pollOutput(t,e,l,o,s,n,i,r,a,u,p){let d="[poll",m=""
const g=this.model.toolbarEvent.getText().match(/\[poll(\s+name=[^\s\]]+)*.*\]/gim)
g&&(d+=` name=poll${g.length+1}`)
let f=r
return f<1&&(f=1),t&&(d+=` type=${t}`),e&&(d+=` results=${e}`),n&&t!==c&&(d+=` min=${n}`),i&&t!==c&&(d+=` max=${i}`),t===h&&(d+=` step=${f}`),d+=" public="+(l?"true":"false"),p&&t!==h&&(d+=` chartType=${p}`),a&&a.length>0&&(d+=` groups=${a}`),u&&(d+=` close=${u.toISOString()}`),d+="]",m+=`${d}\n`,o&&(m+=`# ${o.trim()}\n`),s.length>0&&t!==h&&s.forEach((t=>{t.value.length>0&&(m+=`* ${t.value.trim()}\n`)})),m+="[/poll]\n",m}static#C=(()=>dt7948.n(this.prototype,"pollOutput",[(0,i.default)("pollType","pollResult","publicPoll","pollTitle","pollOptions.@each.value","pollMin","pollMax","pollStep","pollGroups","pollAutoClose","chartType")]))()
minNumOfOptionsValidation(t,e){if(!t){if(e<1)return l.default.create({failed:!0,reason:r.default.t("poll.ui_builder.help.options_min_count")})
if(e>this.siteSettings.poll_maximum_options)return l.default.create({failed:!0,reason:r.default.t("poll.ui_builder.help.options_max_count",{count:this.siteSettings.poll_maximum_options})})}return l.default.create({ok:!0})}static#w=(()=>dt7948.n(this.prototype,"minNumOfOptionsValidation",[(0,i.default)("isNumber","pollOptionsCount")]))()
showMinNumOfOptionsValidation(t){return 1!==t.length||""!==t[0].value}static#O=(()=>dt7948.n(this.prototype,"showMinNumOfOptionsValidation",[(0,i.default)("pollOptions.@each.value")]))()
minMaxValueValidation(t,e,o,s,n,i){if(s=parseInt(s,10)||0,n=parseInt(n,10)||0,i=parseInt(i,10)||0,s<0)return l.default.create({failed:!0,reason:r.default.t("poll.ui_builder.help.invalid_min_value")})
if(n<0||t&&n>e)return l.default.create({failed:!0,reason:r.default.t("poll.ui_builder.help.invalid_max_value")})
if(s>n)return l.default.create({failed:!0,reason:r.default.t("poll.ui_builder.help.invalid_values")})
if(o){if(i<1)return l.default.create({failed:!0,reason:r.default.t("poll.ui_builder.help.min_step_value")})
const t=(n-s+1)/i
if(t<1)return l.default.create({failed:!0,reason:r.default.t("poll.ui_builder.help.options_min_count")})
if(t>this.siteSettings.poll_maximum_options)return l.default.create({failed:!0,reason:r.default.t("poll.ui_builder.help.options_max_count",{count:this.siteSettings.poll_maximum_options})})}return l.default.create({ok:!0})}static#x=(()=>dt7948.n(this.prototype,"minMaxValueValidation",[(0,i.default)("isMultiple","pollOptionsCount","isNumber","pollMin","pollMax","pollStep")]))()
disableInsert(t,e){return!t.ok||!e.ok}static#M=(()=>dt7948.n(this.prototype,"disableInsert",[(0,i.default)("minMaxValueValidation","minNumOfOptionsValidation")]))()
_comboboxOptions(t,e){return[...Array(e-t).keys()].map((e=>({value:e+t,name:e+t})))}onOptionsTextChange(t){this.set("pollOptions",t.target.value.split("\n").map((t=>l.default.create({value:t}))))}static#T=(()=>dt7948.n(this.prototype,"onOptionsTextChange",[l.action]))()
insertPoll(){this.model.toolbarEvent.addText(this.pollOutput),this.closeModal()}static#R=(()=>dt7948.n(this.prototype,"insertPoll",[l.action]))()
toggleAdvanced(){this.toggleProperty("showAdvanced"),this.showAdvanced&&this.set("pollOptionsText",this.pollOptions.map((t=>t.value)).join("\n"))}static#S=(()=>dt7948.n(this.prototype,"toggleAdvanced",[l.action]))()
updateValue(t,e){t.set("value",e.target.value)}static#P=(()=>dt7948.n(this.prototype,"updateValue",[l.action]))()
onInputKeydown(t,e){"Enter"===e.key&&(e.preventDefault(),e.stopPropagation(),""!==e.target.value&&this.addOption(t+1))}static#V=(()=>dt7948.n(this.prototype,"onInputKeydown",[l.action]))()
addOption(t){-1===t&&(t=this.pollOptions.length)
const e=l.default.create({value:""})
this.pollOptions.insertAt(t,e)}static#j=(()=>dt7948.n(this.prototype,"addOption",[l.action]))()
removeOption(t){this.pollOptions.removeObject(t)}static#E=(()=>dt7948.n(this.prototype,"removeOption",[l.action]))()
updatePollType(t,e){e?.preventDefault(),this.set("pollType",t)}static#N=(()=>dt7948.n(this.prototype,"updatePollType",[l.action]))()
togglePublic(){this.set("publicPoll",!this.publicPoll)}static#A=(()=>dt7948.n(this.prototype,"togglePublic",[l.action]))()}t.default=b,(0,e.setComponentTemplate)(u,b)})),define("discourse/plugins/poll/discourse/components/poll-breakdown-chart",["exports","@ember/component","@ember/object/computed","@ember/runloop","@ember/template","@ember-decorators/component","discourse-common/utils/decorators","discourse-i18n","discourse/plugins/poll/lib/chart-colors","discourse/plugins/poll/discourse/components/modal/poll-ui-builder","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
const d=dt7948.c(class extends e.default{group=null
options=null
displayMode=null
highlightedOption=null
setHighlightedOption=null
static#t=(()=>dt7948.g(this.prototype,"data",[(0,l.mapBy)("options","votes")]))()
#D=(()=>{dt7948.i(this,"data")})()
_optionToSlice=null
_previousHighlightedSliceIndex=null
_previousDisplayMode=null
init(){super.init(...arguments),this._optionToSlice={}}didInsertElement(){super.didInsertElement(...arguments)
const t=this.element.querySelector("canvas")
this._chart=new window.Chart(t.getContext("2d"),this.chartConfig)}didReceiveAttrs(){super.didReceiveAttrs(...arguments),this._chart&&(this._updateDisplayMode(),this._updateHighlight())}willDestroy(){super.willDestroy(...arguments),this._chart&&this._chart.destroy()}colorStyle(t,e){return(0,s.htmlSafe)(`background: ${t[e]};`)}static#l=(()=>dt7948.n(this.prototype,"colorStyle",[(0,i.default)("optionColors","index")]))()
chartConfig(t,e){const l=[]
let s=0
this._optionToSlice={},t.forEach(((t,e)=>{t>0&&(l.push(t),this._optionToSlice[e]=s++)}))
const n=l.reduce(((t,e)=>t+e),0),i=(0,a.getColors)(t.length).filter(((e,l)=>t[l]>0))
return{type:u.PIE_CHART_TYPE,plugins:[window.ChartDataLabels],data:{datasets:[{data:l,backgroundColor:i,hoverBorderColor:"#fff"}]},options:{plugins:{tooltip:!1,datalabels:{color:"#333",backgroundColor:"rgba(255, 255, 255, 0.5)",borderRadius:2,font:{family:getComputedStyle(document.body).fontFamily,size:16},padding:{top:2,right:6,bottom:2,left:6},formatter(t){if("percentage"!==e)return t
return`${r.default.toNumber(t/n*100,{precision:1})}%`}}},responsive:!0,aspectRatio:1.1,animation:{duration:0},onHover:(t,e)=>{if(!e.length)return void(0,o.next)((()=>{this.setHighlightedOption(null)}))
const l=e[0].index,s=Object.keys(this._optionToSlice).find((t=>this._optionToSlice[t]===l));(0,o.next)((()=>{this.setHighlightedOption(Number(s))}))}}}}static#o=(()=>dt7948.n(this.prototype,"chartConfig",[(0,i.default)("data","displayMode")]))()
_updateDisplayMode(){if(this.displayMode!==this._previousDisplayMode){const t=this.chartConfig
this._chart.data.datasets=t.data.datasets,this._chart.options=t.options,this._chart.update(),this._previousDisplayMode=this.displayMode}}_updateHighlight(){const t=[]
if(this.highlightedOption){const e=this._optionToSlice[this.highlightedOption]
void 0!==e&&t.push({datasetIndex:0,index:e})}this._chart.setActiveElements(t),this._chart.update()}static#s=(()=>(0,e.setComponentTemplate)((0,p.createTemplateFactory)({id:"YovPpAdq",block:'[[[1,"\\n    "],[10,"label"],[14,0,"poll-breakdown-chart-label"],[12],[1,[30,1]],[13],[1,"\\n    "],[10,"canvas"],[14,0,"poll-breakdown-chart-chart"],[12],[13],[1,"\\n  "]],["@group"],false,[]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-breakdown-chart.js",isStrictMode:!0}),this))()},[(0,n.classNames)("poll-breakdown-chart-container")])
t.default=d})),define("discourse/plugins/poll/discourse/components/poll-breakdown-option",["exports","@ember/component","@ember/modifier","@ember/object/computed","@ember/template","@ember-decorators/component","discourse/lib/computed","discourse-common/helpers/i18n","discourse-common/utils/decorators","discourse-i18n","discourse/plugins/poll/lib/chart-colors","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p,d){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
const c=dt7948.c(class extends e.default{option=null
index=null
totalVotes=null
optionsCount=null
displayMode=null
highlightedOption=null
onMouseOver=null
onMouseOut=null
static#t=(()=>dt7948.g(this.prototype,"highlighted",[(0,i.propertyEqual)("highlightedOption","index")]))()
#L=(()=>{dt7948.i(this,"highlighted")})()
static#l=(()=>dt7948.g(this.prototype,"showPercentage",[(0,o.equal)("displayMode","percentage")]))()
#I=(()=>{dt7948.i(this,"showPercentage")})()
percent(t,e){return u.default.toNumber(t/e*100,{precision:1})}static#o=(()=>dt7948.n(this.prototype,"percent",[(0,a.default)("option.votes","totalVotes")]))()
optionColors(t){return(0,p.getColors)(t)}static#s=(()=>dt7948.n(this.prototype,"optionColors",[(0,a.default)("optionsCount")]))()
colorBackgroundStyle(t){if(t)return(0,s.htmlSafe)("background: rgba(0, 0, 0, 0.1);")}static#n=(()=>dt7948.n(this.prototype,"colorBackgroundStyle",[(0,a.default)("highlighted")]))()
colorPreviewStyle(t,e,l){const o=t?window.Chart.helpers.getHoverColor(e[l]):e[l]
return(0,s.htmlSafe)(`background: ${o};`)}static#i=(()=>dt7948.n(this.prototype,"colorPreviewStyle",[(0,a.default)("highlighted","optionColors","index")]))()
static#h=(()=>(0,e.setComponentTemplate)((0,d.createTemplateFactory)({id:"lkH98VIv",block:'[[[1,"\\n    "],[11,"li"],[24,0,"poll-breakdown-option"],[16,5,[30,0,["colorBackgroundStyle"]]],[24,"role","button"],[4,[32,0],["mouseover",[30,1]],null],[4,[32,0],["mouseout",[30,2]],null],[12],[1,"\\n      "],[10,1],[14,0,"poll-breakdown-option-color"],[15,5,[30,0,["colorPreviewStyle"]]],[12],[13],[1,"\\n\\n      "],[10,1],[14,0,"poll-breakdown-option-count"],[12],[1,"\\n"],[41,[30,0,["showPercentage"]],[[[1,"          "],[1,[28,[32,1],["number.percent"],[["count"],[[30,0,["percent"]]]]]],[1,"\\n"]],[]],[[[1,"          "],[1,[30,3,["votes"]]],[1,"\\n"]],[]]],[1,"      "],[13],[1,"\\n      "],[10,1],[14,0,"poll-breakdown-option-text"],[12],[1,[28,[32,2],[[30,3,["html"]]],null]],[13],[1,"\\n    "],[13],[1,"\\n  "]],["@onMouseOver","@onMouseOut","@option"],false,["if"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-breakdown-option.js",scope:()=>[l.on,r.default,s.htmlSafe],isStrictMode:!0}),this))()},[(0,n.tagName)("")])
t.default=c})),define("discourse/plugins/poll/discourse/components/poll-buttons-dropdown",["exports","@glimmer/component","@ember/helper","@ember/object","@ember/service","discourse/components/d-button","discourse/components/dropdown-menu","discourse-common/helpers/d-icon","float-kit/components/d-menu","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
const d={className:"btn-default export-results",label:"poll.export-results.label",title:"poll.export-results.title",icon:"download",action:"exportResults"},c={className:"btn-default show-breakdown",label:"poll.breakdown.breakdown",icon:"chart-pie",action:"showBreakdown"},h={className:"btn-default toggle-status",label:"poll.open.label",title:"poll.open.title",icon:"unlock-alt",action:"toggleStatus"},m={className:"btn-default toggle-status",label:"poll.close.label",title:"poll.close.title",icon:"lock",action:"toggleStatus"}
class g extends e.default{static#t=(()=>dt7948.g(this.prototype,"currentUser",[s.service]))()
#U=(()=>{dt7948.i(this,"currentUser")})()
static#l=(()=>dt7948.g(this.prototype,"siteSettings",[s.service]))()
#r=(()=>{dt7948.i(this,"siteSettings")})()
constructor(){super(...arguments),this.getDropdownButtonState=!1}dropDownClick(t){this.args.dropDownClick(t)}static#o=(()=>dt7948.n(this.prototype,"dropDownClick",[o.action]))()
get getDropdownContent(){const t=[],e=this.currentUser&&this.currentUser.admin,l=this.siteSettings.data_explorer_enabled,o=this.args.isRankedChoice?this.siteSettings.poll_export_ranked_choice_data_explorer_query_id:this.siteSettings.poll_export_data_explorer_query_id,{closed:s,voters:n,isStaff:i,isMe:r,topicArchived:a,groupableUserFields:u,isAutomaticallyClosed:p}=this.args
if(u.length&&n>0){const e={...c}
e.id=e.action,t.push(e)}if(e&&l&&n>0&&o){const e={...d}
e.id=e.action,t.push(e)}if(this.currentUser&&(r||i)&&!a)if(s){if(!p){const e={...h}
e.id=e.action,t.push(e)}}else{const e={...m}
e.id=e.action,t.push(e)}return t}get showDropdown(){return this.getDropdownContent.length>1}get showDropdownAsButton(){return 1===this.getDropdownContent.length}static#s=(()=>(0,u.setComponentTemplate)((0,p.createTemplateFactory)({id:"5lx/VHAX",block:'[[[1,"\\n    "],[10,0],[14,0,"poll-buttons-dropdown"],[12],[1,"\\n"],[41,[30,0,["showDropdown"]],[[[1,"        "],[8,[32,0],[[24,0,"widget-dropdown-header"]],null,[["trigger","content"],[[[[1,"\\n            "],[1,[28,[32,1],["cog"],null]],[1,"\\n          "]],[]],[[[1,"\\n            "],[8,[32,2],null,null,[["default"],[[[[1,"\\n"],[42,[28,[31,2],[[28,[31,2],[[30,0,["getDropdownContent"]]],null]],null],null,[[[1,"                "],[8,[30,1,["item"]],null,null,[["default"],[[[[1,"\\n                  "],[8,[32,3],[[16,0,[29,["widget-button ",[30,2,["className"]]]]]],[["@icon","@label","@action"],[[30,2,["icon"]],[30,2,["label"]],[28,[32,4],[[30,0,["dropDownClick"]],[30,2,["action"]]],null]]],null],[1,"\\n                "]],[]]]]],[1,"\\n                "],[8,[30,1,["divider"]],null,null,null],[1,"\\n"]],[2]],null],[1,"            "]],[1]]]]],[1,"\\n          "]],[]]]]],[1,"\\n"]],[]],[[[41,[30,0,["showDropdownAsButton"]],[[[1,"        "],[8,[32,3],[[16,0,[29,["widget-button ",[28,[32,5],[[30,0,["getDropdownContent"]],"0.className"],null]]]]],[["@icon","@label","@action"],[[28,[32,5],[[30,0,["getDropdownContent"]],"0.icon"],null],[28,[32,5],[[30,0,["getDropdownContent"]],"0.label"],null],[28,[32,4],[[30,0,["dropDownClick"]],[28,[32,5],[[30,0,["getDropdownContent"]],"0.action"],null]],null]]],null],[1,"\\n      "]],[]],null]],[]]],[1,"    "],[13],[1,"\\n  "]],["dropdown","content"],false,["if","each","-track-array"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-buttons-dropdown.js",scope:()=>[a.default,r.default,i.default,n.default,l.fn,o.get],isStrictMode:!0}),this))()}t.default=g})),define("discourse/plugins/poll/discourse/components/poll-info",["exports","@glimmer/component","@ember/service","@ember/template","discourse/lib/formatter","discourse-common/helpers/d-icon","discourse-i18n","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
const u="staff_only"
class p extends e.default{static#t=(()=>dt7948.g(this.prototype,"currentUser",[l.service]))()
#U=(()=>{dt7948.i(this,"currentUser")})()
get multipleHelpText(){const{min:t,max:e,options:l}=this.args,s=l.length
if(e>0){if(t===e&&t>1)return(0,o.htmlSafe)(i.default.t("poll.multiple.help.x_options",{count:t}))
if(t>1)return e<s?(0,o.htmlSafe)(i.default.t("poll.multiple.help.between_min_and_max_options",{min:t,max:e})):(0,o.htmlSafe)(i.default.t("poll.multiple.help.at_least_min_options",{count:t}))
if(e<=s)return(0,o.htmlSafe)(i.default.t("poll.multiple.help.up_to_max_options",{count:e}))}}get votersLabel(){return i.default.t("poll.voters",{count:this.args.voters})}get showTotalVotes(){return this.args.isMultiple&&(this.args.showResults||this.args.closed)}get totalVotes(){return this.args.options.reduce(((t,e)=>t+parseInt(e.votes,10)),0)}get totalVotesLabel(){return i.default.t("poll.total_votes",{count:this.totalVotes})}get automaticCloseAgeLabel(){return i.default.t("poll.automatic_close.age",this.age)}get automaticCloseClosesInLabel(){return i.default.t("poll.automatic_close.closes_in",this.timeLeft)}get showMultipleHelpText(){return this.args.isMultiple&&!this.args.showResults&&!this.args.closed}get closeTitle(){const t=moment.utc(this.args.close,"YYYY-MM-DD HH:mm:ss Z")
return t.isValid()?t.format("LLL"):""}get age(){const t=moment.utc(this.args.close,"YYYY-MM-DD HH:mm:ss Z")
return t.isValid()?(0,s.relativeAge)(t.toDate(),{addAgo:!0}):0}get timeLeft(){const t=moment.utc(this.args.close,"YYYY-MM-DD HH:mm:ss Z")
return t.isValid()?moment().to(t,!0):0}get resultsOnVote(){return!("on_vote"!==this.args.results||this.args.hasVoted||this.currentUser&&this.args.postUserId===this.currentUser.id)}get resultsOnVoteTitle(){return(0,o.htmlSafe)(i.default.t("poll.results.vote.title"))}get resultsOnClose(){return"on_close"===this.args.results&&!this.args.closed}get resultsOnCloseTitle(){return(0,o.htmlSafe)(i.default.t("poll.results.closed.title"))}get resultsStaffOnly(){return this.args.results===u&&!(this.currentUser&&this.currentUser.staff)}get resultsStaffOnlyTitle(){return(0,o.htmlSafe)(i.default.t("poll.results.staff.title"))}get publicTitle(){return!this.args.closed&&!this.args.showResults&&this.args.isPublic&&this.args.results!==u}get publicTitleLabel(){return(0,o.htmlSafe)(i.default.t("poll.public.title"))}get showInstructionsSection(){return this.showMultipleHelpText||this.args.close||this.resultsOnVote||this.resultsOnClose||this.resultsStaffOnly||this.publicTitle}static#l=(()=>(0,r.setComponentTemplate)((0,a.createTemplateFactory)({id:"yopY6+yM",block:'[[[1,"\\n    "],[10,0],[14,0,"poll-info"],[12],[1,"\\n      "],[10,0],[14,0,"poll-info_counts"],[12],[1,"\\n        "],[10,0],[14,0,"poll-info_counts-count"],[12],[1,"\\n          "],[10,1],[14,0,"info-number"],[12],[1,[30,1]],[13],[1,"\\n          "],[10,1],[14,0,"info-label"],[12],[1,[30,0,["votersLabel"]]],[13],[1,"\\n        "],[13],[1,"\\n"],[41,[30,0,["showTotalVotes"]],[[[1,"          "],[10,0],[14,0,"poll-info_counts-count"],[12],[1,"\\n            "],[10,1],[14,0,"info-number"],[12],[1,[30,0,["totalVotes"]]],[13],[1,"\\n            "],[10,1],[14,0,"info-label"],[12],[1,[30,0,["totalVotesLabel"]]],[13],[1,"\\n          "],[13],[1,"\\n"]],[]],null],[1,"      "],[13],[1,"\\n"],[41,[30,0,["showInstructionsSection"]],[[[1,"        "],[10,"ul"],[14,0,"poll-info_instructions"],[12],[1,"\\n"],[41,[30,0,["showMultipleHelpText"]],[[[1,"            "],[10,"li"],[14,0,"multiple-help-text"],[12],[1,"\\n              "],[1,[28,[32,0],["list-ul"],null]],[1,"\\n              "],[10,1],[12],[1,[30,0,["multipleHelpText"]]],[13],[1,"\\n            "],[13],[1,"\\n"]],[]],null],[41,[30,0,["poll","close"]],[[[41,[30,0,["isAutomaticallyClosed"]],[[[1,"              "],[10,"li"],[15,"title",[30,0,["title"]]],[12],[1,"\\n                "],[1,[28,[32,0],["lock"],null]],[1,"\\n                "],[10,1],[12],[1,[30,0,["automaticCloseAgeLabel"]]],[13],[1,"\\n              "],[13],[1,"\\n"]],[]],[[[1,"              "],[10,"li"],[15,"title",[30,0,["title"]]],[12],[1,"\\n                "],[1,[28,[32,0],["far-clock"],null]],[1,"\\n                "],[10,1],[12],[1,[30,0,["automaticCloseClosesInLabel"]]],[13],[1,"\\n              "],[13],[1,"\\n"]],[]]]],[]],null],[41,[30,0,["resultsOnVote"]],[[[1,"            "],[10,"li"],[14,0,"results-on-vote"],[12],[1,"\\n              "],[1,[28,[32,0],["check"],null]],[1,"\\n              "],[10,1],[12],[1,[30,0,["resultsOnVoteTitle"]]],[13],[1,"\\n            "],[13],[1,"\\n"]],[]],null],[41,[30,0,["resultsOnClose"]],[[[1,"            "],[10,"li"],[14,0,"results-on-close"],[12],[1,"\\n              "],[1,[28,[32,0],["lock"],null]],[1,"\\n              "],[10,1],[12],[1,[30,0,["resultsOnCloseTitle"]]],[13],[1,"\\n            "],[13],[1,"\\n"]],[]],null],[41,[30,0,["resultsStaffOnly"]],[[[1,"            "],[10,"li"],[14,0,"results-staff-only"],[12],[1,"\\n              "],[1,[28,[32,0],["shield-alt"],null]],[1,"\\n              "],[10,1],[12],[1,[30,0,["resultsStaffOnlyTitle"]]],[13],[1,"\\n            "],[13],[1,"\\n"]],[]],null],[41,[30,0,["publicTitle"]],[[[1,"            "],[10,"li"],[14,0,"is-public"],[12],[1,"\\n              "],[1,[28,[32,0],["far-eye"],null]],[1,"\\n              "],[10,1],[12],[1,[30,0,["publicTitleLabel"]]],[13],[1,"\\n            "],[13],[1,"\\n"]],[]],null],[1,"        "],[13],[1,"\\n"]],[]],null],[1,"    "],[13],[1,"\\n  "]],["@voters"],false,["if"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-info.js",scope:()=>[n.default],isStrictMode:!0}),this))()}t.default=p})),define("discourse/plugins/poll/discourse/components/poll-option-ranked-choice-dropdown",["exports","@glimmer/component","@glimmer/tracking","@ember/helper","@ember/object","discourse/components/d-button","discourse/components/dropdown-menu","discourse-common/helpers/d-icon","discourse-i18n","float-kit/components/d-menu","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p,d){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class c extends e.default{static#t=(()=>dt7948.g(this.prototype,"rank",[l.tracked]))()
#H=(()=>{dt7948.i(this,"rank")})()
constructor(){super(...arguments),this.rank=this.args.rank}onRegisterApi(t){this.dMenu=t}static#l=(()=>dt7948.n(this.prototype,"onRegisterApi",[s.action]))()
selectRank(t,e){this.args.sendRank(t,e),this.rank=0===e?a.default.t("poll.options.ranked_choice.abstain"):e,this.dMenu.close()}static#o=(()=>dt7948.n(this.prototype,"selectRank",[s.action]))()
get rankLabel(){return 0===this.rank?a.default.t("poll.options.ranked_choice.abstain"):this.rank}static#s=(()=>(0,p.setComponentTemplate)((0,d.createTemplateFactory)({id:"v+uOyjgE",block:'[[[1,"\\n    "],[8,[32,0],null,[["@onRegisterApi"],[[30,0,["onRegisterApi"]]]],[["trigger","content"],[[[[1,"\\n        "],[10,1],[14,0,"d-button-label"],[12],[1,"\\n          "],[1,[30,0,["rankLabel"]]],[1,"\\n        "],[13],[1,"\\n        "],[1,[28,[32,1],["angle-down"],null]],[1,"\\n      "]],[]],[[[1,"\\n        "],[8,[32,2],null,null,[["default"],[[[[1,"\\n"],[42,[28,[31,1],[[28,[31,1],[[30,2]],null]],null],null,[[[1,"            "],[8,[30,1,["item"]],null,null,[["default"],[[[[1,"\\n              "],[8,[32,3],[[24,0,"btn-transparent poll-option-dropdown"]],[["@translatedLabel","@action"],[[30,3,["name"]],[28,[32,4],[[30,0,["selectRank"]],[30,4,["id"]],[30,3,["id"]]],null]]],null],[1,"\\n            "]],[]]]]],[1,"\\n"]],[3]],null],[1,"        "]],[1]]]]],[1,"\\n      "]],[]]]]],[1,"\\n  "]],["dropdown","@rankedChoiceDropdownContent","content","@option"],false,["each","-track-array"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-option-ranked-choice-dropdown.js",scope:()=>[u.default,r.default,i.default,n.default,o.fn],isStrictMode:!0}),this))()}t.default=c})),define("discourse/plugins/poll/discourse/components/poll-option-ranked-choice",["exports","@glimmer/component","@ember/object","@ember/service","@ember/template","discourse/components/d-button","discourse/helpers/route-action","discourse-common/helpers/i18n","discourse/plugins/poll/discourse/components/poll-option-ranked-choice-dropdown","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class d extends e.default{static#t=(()=>dt7948.g(this.prototype,"currentUser",[o.service]))()
#U=(()=>{dt7948.i(this,"currentUser")})()
sendRank(t){let e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0
this.args.sendRank(t,e)}static#l=(()=>dt7948.n(this.prototype,"sendRank",[l.action]))()
static#o=(()=>(0,u.setComponentTemplate)((0,p.createTemplateFactory)({id:"s3KDM/LE",block:'[[[1,"\\n    "],[10,0],[14,"tabindex","0"],[14,0,"ranked-choice-poll-option"],[15,"data-poll-option-id",[30,1,["id"]]],[15,"data-poll-option-rank",[30,1,["rank"]]],[12],[1,"\\n"],[41,[30,0,["currentUser"]],[[[1,"        "],[8,[32,0],null,[["@rank","@option","@rankedChoiceDropdownContent","@sendRank"],[[30,1,["rank"]],[30,1],[30,2],[30,0,["sendRank"]]]],null],[1,"\\n"]],[]],[[[1,"        "],[8,[32,1],[[24,0,"btn-default"],[16,"onclick",[28,[32,2],["showLogin"],null]]],null,[["default"],[[[[1,[28,[32,3],["poll.options.ranked_choice.login"],null]]],[]]]]],[1,"\\n"]],[]]],[1,"      "],[10,1],[14,0,"option-text"],[12],[1,[28,[32,4],[[30,1,["html"]]],null]],[13],[1,"\\n    "],[13],[1,"\\n  "]],["@option","@rankedChoiceDropdownContent"],false,["if"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-option-ranked-choice.js",scope:()=>[a.default,n.default,i.default,r.default,s.htmlSafe],isStrictMode:!0}),this))()}t.default=d})),define("discourse/plugins/poll/discourse/components/poll-options",["exports","@glimmer/component","@ember/helper","@ember/modifier","@ember/object","@ember/service","@ember/template","discourse/helpers/concat-class","discourse/helpers/route-action","discourse-common/helpers/d-icon","discourse/plugins/poll/discourse/components/poll-option-ranked-choice","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p,d,c){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class h extends e.default{static#t=(()=>dt7948.g(this.prototype,"currentUser",[n.service]))()
#U=(()=>{dt7948.i(this,"currentUser")})()
isChosen=t=>this.args.votes.includes(t.id)
sendClick(t){this.args.sendOptionSelect(t)}static#l=(()=>dt7948.n(this.prototype,"sendClick",[s.action]))()
sendRank(t){let e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0
this.args.sendOptionSelect(t,e)}static#o=(()=>dt7948.n(this.prototype,"sendRank",[s.action]))()
static#s=(()=>(0,d.setComponentTemplate)((0,c.createTemplateFactory)({id:"hH8+3GXY",block:'[[[1,"\\n    "],[10,"ul"],[15,0,[28,[32,0],[[52,[30,1],"ranked-choice-poll-options"]],null]],[12],[1,"\\n"],[42,[28,[31,2],[[28,[31,2],[[30,2]],null]],null],null,[[[41,[30,1],[[[1,"          "],[8,[32,1],null,[["@option","@rankedChoiceDropdownContent","@sendRank"],[[30,3],[30,4],[30,0,["sendRank"]]]],null],[1,"\\n"]],[]],[[[1,"          "],[10,"li"],[14,"tabindex","0"],[15,"data-poll-option-id",[30,3,["id"]]],[12],[1,"\\n"],[41,[30,0,["currentUser"]],[[[1,"              "],[11,"button"],[4,[32,2],["click",[28,[32,3],[[30,0,["sendClick"]],[30,3]],null]],null],[12],[1,"\\n"],[41,[28,[30,0,["isChosen"]],[[30,3]],null],[[[41,[30,5],[[[1,"                    "],[1,[28,[32,4],["far-check-square"],null]],[1,"\\n"]],[]],[[[1,"                    "],[1,[28,[32,4],["circle"],null]],[1,"\\n"]],[]]]],[]],[[[41,[30,5],[[[1,"                    "],[1,[28,[32,4],["far-square"],null]],[1,"\\n"]],[]],[[[1,"                    "],[1,[28,[32,4],["far-circle"],null]],[1,"\\n"]],[]]]],[]]],[1,"                "],[10,1],[14,0,"option-text"],[12],[1,[28,[32,5],[[30,3,["html"]]],null]],[13],[1,"\\n              "],[13],[1,"\\n"]],[]],[[[1,"              "],[10,"button"],[15,"onclick",[28,[32,6],["showLogin"],null]],[12],[1,"\\n"],[41,[28,[30,0,["isChosen"]],[[30,3]],null],[[[41,[30,5],[[[1,"                    "],[1,[28,[32,4],["far-check-square"],null]],[1,"\\n"]],[]],[[[1,"                    "],[1,[28,[32,4],["circle"],null]],[1,"\\n"]],[]]]],[]],[[[41,[30,5],[[[1,"                    "],[1,[28,[32,4],["far-square"],null]],[1,"\\n"]],[]],[[[1,"                    "],[1,[28,[32,4],["far-circle"],null]],[1,"\\n"]],[]]]],[]]],[1,"                "],[10,1],[14,0,"option-text"],[12],[1,[28,[32,5],[[30,3,["html"]]],null]],[13],[1,"\\n              "],[13],[1,"\\n"]],[]]],[1,"          "],[13],[1,"\\n"]],[]]]],[3]],null],[1,"    "],[13],[1,"\\n  "]],["@isRankedChoice","@options","option","@rankedChoiceDropdownContent","@isCheckbox"],false,["if","each","-track-array"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-options.js",scope:()=>[r.default,p.default,o.on,l.fn,u.default,i.htmlSafe,a.default],isStrictMode:!0}),this))()}t.default=h})),define("discourse/plugins/poll/discourse/components/poll-results-pie",["exports","@glimmer/component","@ember/object","@ember/render-modifiers/modifiers/did-insert","@ember/template","ember-modifier","discourse/lib/load-script","discourse/plugins/poll/lib/chart-colors","discourse/plugins/poll/discourse/components/modal/poll-ui-builder","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class d extends e.default{htmlLegendPlugin={id:"htmlLegend",afterUpdate(t,e,l){const o=document.getElementById(l.containerID)
if(!o)return
o.innerHTML=""
t.options.plugins.legend.labels.generateLabels(t).forEach((e=>{const l=document.createElement("li")
l.classList.add("legend"),l.onclick=()=>{t.toggleDataVisibility(e.index),t.update()}
const s=document.createElement("span")
s.classList.add("swatch"),s.style.background=e.fillStyle
const n=document.createElement("span")
n.style.color=e.fontColor,n.innerHTML=e.text,t.getDataVisibility(e.index)?l.style.opacity=1:l.style.opacity=.2,l.appendChild(s),l.appendChild(n),o.appendChild(l)}))}}
stripHtml=t=>(new DOMParser).parseFromString(t,"text/html").body.textContent||""
pieChartConfig=(()=>{var t=this
return function(e,l){let o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{}
const s="aspectRatio"in o?o.aspectRatio:2.2,n=l.map((e=>t.stripHtml(e)))
return{type:a.PIE_CHART_TYPE,data:{datasets:[{data:e,backgroundColor:(0,r.getColors)(e.length)}],labels:n},plugins:[t.htmlLegendPlugin],options:{responsive:!0,aspectRatio:s,animation:{duration:0},plugins:{legend:{labels:{generateLabels:()=>l.map(((t,l)=>({fillStyle:(0,r.getColors)(e.length)[l],text:t,index:l})))},display:!1},htmlLegend:{containerID:o?.legendContainerId}}}}}})()
registerLegendElement=(()=>(0,n.modifier)((t=>{this.legendElement=t})))()
registerCanvasElement=(()=>(0,n.modifier)((t=>{this.canvasElement=t})))()
get canvasId(){return(0,s.htmlSafe)(`poll-results-chart-${this.args.id}`)}get legendId(){return(0,s.htmlSafe)(`poll-results-legend-${this.args.id}`)}async drawPie(){await(0,i.default)("/javascripts/Chart.min.js")
const t=this.args.options.mapBy("votes"),e=this.args.options.mapBy("html"),l=this.pieChartConfig(t,e,{legendContainerId:this.legendElement.id}),o=this.canvasElement
this._chart=new Chart(o.getContext("2d"),l)}static#t=(()=>dt7948.n(this.prototype,"drawPie",[l.action]))()
static#l=(()=>(0,u.setComponentTemplate)((0,p.createTemplateFactory)({id:"Vsgg5HC0",block:'[[[1,"\\n    "],[10,0],[14,0,"poll-results-chart"],[12],[1,"\\n      "],[11,"canvas"],[16,1,[30,0,["canvasId"]]],[24,0,"poll-results-canvas"],[4,[32,0],[[30,0,["drawPie"]]],null],[4,[32,0],[[30,0,["registerCanvasElement"]]],null],[12],[13],[1,"\\n      "],[11,"ul"],[16,1,[30,0,["legendId"]]],[24,0,"pie-chart-legends"],[4,[32,0],[[30,0,["registerLegendElement"]]],null],[12],[1,"\\n      "],[13],[1,"\\n    "],[13],[1,"\\n  "]],[],false,[]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-results-pie.js",scope:()=>[o.default],isStrictMode:!0}),this))()}t.default=d})),define("discourse/plugins/poll/discourse/components/poll-results-ranked-choice",["exports","@glimmer/component","discourse-common/helpers/i18n","discourse-i18n","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class i extends e.default{get rankedChoiceWinnerText(){return o.default.t("poll.ranked_choice.winner",{count:this.args.rankedChoiceOutcome.round_activity.length,winner:this.args.rankedChoiceOutcome.winning_candidate.html})}get rankedChoiceTiedText(){return o.default.t("poll.ranked_choice.tied",{count:this.args.rankedChoiceOutcome.round_activity.length})}static#t=(()=>(0,s.setComponentTemplate)((0,n.createTemplateFactory)({id:"xqv5x7Ke",block:'[[[1,"\\n    "],[10,"h3"],[14,0,"poll-results-ranked-choice-subtitle-rounds"],[12],[1,"\\n      "],[1,[28,[32,0],["poll.ranked_choice.title.rounds"],null]],[1,"\\n    "],[13],[1,"\\n    "],[10,"table"],[14,0,"poll-results-ranked-choice"],[12],[1,"\\n      "],[10,"thead"],[12],[1,"\\n        "],[10,"tr"],[12],[1,"\\n          "],[10,"th"],[12],[1,[28,[32,0],["poll.ranked_choice.round"],null]],[13],[1,"\\n          "],[10,"th"],[12],[1,[28,[32,0],["poll.ranked_choice.majority"],null]],[13],[1,"\\n          "],[10,"th"],[12],[1,[28,[32,0],["poll.ranked_choice.eliminated"],null]],[13],[1,"\\n        "],[13],[1,"\\n      "],[13],[1,"\\n      "],[10,"tbody"],[12],[1,"\\n"],[42,[28,[31,1],[[28,[31,1],[[30,1,["round_activity"]]],null]],null],null,[[[41,[30,2,["majority"]],[[[1,"            "],[10,"tr"],[12],[1,"\\n              "],[10,"td"],[12],[1,[30,2,["round"]]],[13],[1,"\\n              "],[10,"td"],[12],[1,[30,2,["majority","html"]]],[13],[1,"\\n              "],[10,"td"],[12],[1,[28,[32,0],["poll.ranked_choice.none"],null]],[13],[1,"\\n            "],[13],[1,"\\n"]],[]],[[[1,"            "],[10,"tr"],[12],[1,"\\n              "],[10,"td"],[12],[1,[30,2,["round"]]],[13],[1,"\\n              "],[10,"td"],[12],[1,[28,[32,0],["poll.ranked_choice.none"],null]],[13],[1,"\\n              "],[10,"td"],[12],[1,"\\n"],[42,[28,[31,1],[[28,[31,1],[[30,2,["eliminated"]]],null]],null],null,[[[1,"                  "],[1,[30,3,["html"]]],[1,"\\n"]],[3]],null],[1,"              "],[13],[1,"\\n            "],[13],[1,"\\n"]],[]]]],[2]],null],[1,"      "],[13],[1,"\\n    "],[13],[1,"\\n    "],[10,"h3"],[14,0,"poll-results-ranked-choice-subtitle-outcome"],[12],[1,"\\n      "],[1,[28,[32,0],["poll.ranked_choice.title.outcome"],null]],[1,"\\n    "],[13],[1,"\\n"],[41,[30,1,["tied"]],[[[1,"      "],[10,1],[14,0,"poll-results-ranked-choice-info"],[12],[1,[30,0,["rankedChoiceTiedText"]]],[13],[1,"\\n      "],[10,"ul"],[14,0,"poll-results-ranked-choice-tied-candidates"],[12],[1,"\\n"],[42,[28,[31,1],[[28,[31,1],[[30,1,["tied_candidates"]]],null]],null],null,[[[1,"          "],[10,"li"],[14,0,"poll-results-ranked-choice-tied-candidate"],[12],[1,[30,4,["html"]]],[13],[1,"\\n"]],[4]],null],[1,"      "],[13],[1,"\\n"]],[]],[[[1,"      "],[10,1],[14,0,"poll-results-ranked-choice-info"],[12],[1,[30,0,["rankedChoiceWinnerText"]]],[13],[1,"\\n"]],[]]],[1,"  "]],["@rankedChoiceOutcome","round","eliminated","tied_candidate"],false,["each","-track-array","if"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-results-ranked-choice.js",scope:()=>[l.default],isStrictMode:!0}),this))()}t.default=i})),define("discourse/plugins/poll/discourse/components/poll-results-standard",["exports","@glimmer/component","@ember/helper","@ember/template","discourse-common/helpers/i18n","discourse/plugins/poll/lib/even-round","discourse/plugins/poll/discourse/components/poll-voters","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class u extends e.default{orderOptions=t=>t.sort(((t,e)=>t.votes<e.votes?1:t.votes===e.votes?t.html<e.html?-1:1:-1))
getPercentages=(t,e)=>0===e?Array(t.length).fill(0):t.map((t=>100*t.votes/e))
roundPercentages=t=>this.isMultiple?t.map(Math.floor):(0,n.default)(t)
enrichOptions=(t,e)=>(t.forEach(((t,l)=>{const o=e[l].toString(),s=(this.args.vote||[]).includes(t.id)
t.percentage=o,t.chosen=s
let n=this.args.isPublic&&this.args.voters[t.id]||[]
t.voters=[...n]})),t)
get votersCount(){return this.args.votersCount||0}get orderedOptions(){const t=this.orderOptions([...this.args.options]),e=this.getPercentages(t,this.votersCount),l=this.roundPercentages(e)
return this.enrichOptions(t,l)}get isMultiple(){return"multiple"===this.args.pollType}static#t=(()=>(0,r.setComponentTemplate)((0,a.createTemplateFactory)({id:"3hd05QoU",block:'[[[1,"\\n    "],[10,"ul"],[14,0,"results"],[12],[1,"\\n"],[42,[28,[31,1],[[28,[31,1],[[30,0,["orderedOptions"]]],null]],null],"voters",[[[1,"        "],[10,"li"],[15,0,[52,[30,1,["chosen"]],"chosen",""]],[12],[1,"\\n          "],[10,0],[14,0,"option"],[12],[1,"\\n            "],[10,2],[12],[1,"\\n"],[41,[51,[30,2]],[[[1,"                "],[10,1],[14,0,"percentage"],[12],[1,[28,[32,0],["number.percent"],[["count"],[[30,1,["percentage"]]]]]],[13],[1,"\\n"]],[]],null],[1,"              "],[10,1],[14,0,"option-text"],[12],[1,[28,[32,1],[[30,1,["html"]]],null]],[13],[1,"\\n            "],[13],[1,"\\n"],[41,[51,[30,2]],[[[1,"              "],[10,0],[14,0,"bar-back"],[12],[1,"\\n                "],[10,0],[14,0,"bar"],[15,5,[28,[32,1],[[28,[32,2],["width:",[30,1,["percentage"]],"%"],null]],null]],[12],[13],[1,"\\n              "],[13],[1,"\\n"]],[]],null],[41,[30,3],[[[1,"              "],[8,[32,3],null,[["@postId","@pollType","@optionId","@pollName","@isRankedChoice","@totalVotes","@voters","@fetchVoters","@loading"],[[30,4],[30,5],[30,1,["id"]],[30,6],[30,2],[30,1,["votes"]],[30,1,["voters"]],[30,7],[30,1,["loading"]]]],null],[1,"\\n"]],[]],null],[1,"          "],[13],[1,"\\n        "],[13],[1,"\\n"]],[1]],null],[1,"    "],[13],[1,"\\n  "]],["option","@isRankedChoice","@isPublic","@postId","@pollType","@pollName","@fetchVoters"],false,["each","-track-array","if","unless"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-results-standard.js",scope:()=>[s.default,o.htmlSafe,l.concat,i.default],isStrictMode:!0}),this))()}t.default=u})),define("discourse/plugins/poll/discourse/components/poll-results-tabs",["exports","@glimmer/component","@glimmer/tracking","@ember/helper","@ember/object","truth-helpers","discourse/components/d-button","discourse-i18n","discourse/plugins/poll/discourse/components/poll-results-ranked-choice","discourse/plugins/poll/discourse/components/poll-results-standard","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p,d){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class c extends e.default{static#t=(()=>dt7948.g(this.prototype,"activeTab",[l.tracked]))()
#B=(()=>{dt7948.i(this,"activeTab")})()
tabOne=(()=>r.default.t("poll.results.tabs.votes"))()
tabTwo=(()=>r.default.t("poll.results.tabs.outcome"))()
constructor(){super(...arguments),this.activeTab=this.args.isRankedChoice&&this.args.isPublic?this.tabs[1]:this.tabs[0]}get tabs(){let t=[]
return(!this.args.isRankedChoice||this.args.isRankedChoice&&this.args.isPublic)&&t.push(this.tabOne),this.args.isRankedChoice&&t.push(this.tabTwo),t}selectTab(t){this.activeTab=t}static#l=(()=>dt7948.n(this.prototype,"selectTab",[s.action]))()
static#o=(()=>(0,p.setComponentTemplate)((0,d.createTemplateFactory)({id:"ZM46CzDA",block:'[[[1,"\\n    "],[10,0],[14,0,"tab-container"],[12],[1,"\\n      "],[10,"ul"],[14,0,"tabs nav nav-items"],[12],[1,"\\n"],[42,[28,[31,1],[[28,[31,1],[[30,0,["tabs"]]],null]],null],null,[[[1,"          "],[10,"li"],[15,0,[29,["tab nav-item ",[52,[28,[32,0],[[30,1],[30,0,["activeTab"]]],null],"active"]]]],[12],[1,"\\n            "],[8,[32,1],[[24,0,"nav-btn"]],[["@action"],[[28,[32,2],[[30,0,["selectTab"]],[30,1]],null]]],[["default"],[[[[1,"\\n              "],[1,[30,1]],[1,"\\n            "]],[]]]]],[1,"\\n          "],[13],[1,"\\n"]],[1]],null],[1,"      "],[13],[1,"\\n      "],[10,0],[14,0,"tab-content"],[12],[1,"\\n"],[41,[28,[32,0],[[30,0,["activeTab"]],[30,0,["tabOne"]]],null],[[[1,"          "],[8,[32,3],null,[["@options","@pollName","@pollType","@isPublic","@isRankedChoice","@postId","@vote","@voters","@votersCount","@fetchVoters"],[[30,2],[30,3],[30,4],[30,5],[30,6],[30,7],[30,8],[30,9],[30,10],[30,11]]],null],[1,"\\n"]],[]],null],[1,"\\n"],[41,[28,[32,0],[[30,0,["activeTab"]],[30,0,["tabTwo"]]],null],[[[1,"          "],[8,[32,4],null,[["@rankedChoiceOutcome"],[[30,12]]],null],[1,"\\n"]],[]],null],[1,"      "],[13],[1,"\\n    "],[13],[1,"\\n  "]],["tab","@options","@pollName","@pollType","@isPublic","@isRankedChoice","@postId","@vote","@voters","@votersCount","@fetchVoters","@rankedChoiceOutcome"],false,["each","-track-array","if"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-results-tabs.js",scope:()=>[n.eq,i.default,o.fn,u.default,a.default],isStrictMode:!0}),this))()}t.default=c})),define("discourse/plugins/poll/discourse/components/poll-voters-ranked-choice",["exports","@glimmer/component","truth-helpers","discourse/helpers/bound-avatar-template","discourse-common/helpers/d-icon","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class r extends e.default{groupVotersByRank=t=>t.reduce(((t,e)=>{const l=e.rank
return t[l]??=[],t[l].push(e),t}),{})
get rankedChoiceVoters(){const t=[...this.args.voters],e=this.groupVotersByRank(t)
return Object.keys(e).map((t=>({rank:t,voters:e[t]})))}static#t=(()=>(0,n.setComponentTemplate)((0,i.createTemplateFactory)({id:"VHdWo9eb",block:'[[[1,"\\n"],[42,[28,[31,1],[[28,[31,1],[[30,0,["rankedChoiceVoters"]]],null]],null],null,[[[1,"      "],[10,"ul"],[12],[1,"\\n"],[41,[28,[32,0],[[30,1,["rank"]],"Abstain"],null],[[[1,"          "],[10,1],[14,0,"rank"],[12],[1,[28,[32,1],["ban"],null]],[13],[1,"\\n"]],[]],[[[1,"          "],[10,1],[14,0,"rank"],[12],[1,[30,1,["rank"]]],[13],[1,"\\n"]],[]]],[42,[28,[31,1],[[28,[31,1],[[30,1,["voters"]]],null]],null],null,[[[1,"          "],[10,"li"],[12],[1,"\\n            "],[1,[28,[32,2],[[30,2,["user","avatar_template"]],"tiny"],null]],[1,"\\n          "],[13],[1,"\\n"]],[2]],null],[1,"      "],[13],[1,"\\n"]],[1]],null],[1,"  "]],["rank","user"],false,["each","-track-array","if"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-voters-ranked-choice.js",scope:()=>[l.eq,s.default,o.default],isStrictMode:!0}),this))()}t.default=r})),define("discourse/plugins/poll/discourse/components/poll-voters",["exports","@glimmer/component","@ember/helper","discourse/components/conditional-loading-spinner","discourse/components/d-button","discourse/helpers/bound-avatar-template","discourse/plugins/poll/discourse/components/poll-voters-ranked-choice","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
class u extends e.default{get showMore(){return this.args.voters.length<this.args.totalVotes}static#t=(()=>(0,r.setComponentTemplate)((0,a.createTemplateFactory)({id:"K7Ksc5uF",block:'[[[1,"\\n    "],[10,0],[14,0,"poll-voters"],[12],[1,"\\n      "],[10,"ul"],[14,0,"poll-voters-list"],[12],[1,"\\n"],[41,[30,1],[[[1,"          "],[8,[32,0],null,[["@voters"],[[30,2]]],null],[1,"\\n"]],[]],[[[42,[28,[31,2],[[28,[31,2],[[30,2]],null]],null],null,[[[1,"            "],[10,"li"],[12],[1,"\\n              "],[1,[28,[32,1],[[30,3,["avatar_template"]],"tiny"],null]],[1,"\\n            "],[13],[1,"\\n"]],[3]],null]],[]]],[1,"      "],[13],[1,"\\n"],[41,[30,0,["showMore"]],[[[1,"        "],[8,[32,2],null,[["@condition"],[[30,4]]],[["default"],[[[[1,"\\n          "],[8,[32,3],[[24,0,"poll-voters-toggle-expand"]],[["@action","@icon"],[[28,[32,4],[[30,5],[30,6]],null],"chevron-down"]],null],[1,"\\n        "]],[]]]]],[1,"\\n"]],[]],null],[1,"    "],[13],[1,"\\n  "]],["@isRankedChoice","@voters","user","@loading","@fetchVoters","@optionId"],false,["if","each","-track-array"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll-voters.js",scope:()=>[i.default,n.default,o.default,s.default,l.fn],isStrictMode:!0}),this))()}t.default=u})),define("discourse/plugins/poll/discourse/components/poll",["exports","@glimmer/component","@glimmer/tracking","@ember/modifier","@ember/object","@ember/render-modifiers/modifiers/did-update","@ember/service","@ember/template","discourse/lib/ajax","discourse/lib/ajax-error","discourse/lib/round","discourse-common/helpers/d-icon","discourse-common/helpers/i18n","discourse-i18n","discourse/plugins/poll/discourse/components/modal/poll-breakdown","discourse/plugins/poll/discourse/components/modal/poll-ui-builder","discourse/plugins/poll/discourse/components/poll-buttons-dropdown","discourse/plugins/poll/discourse/components/poll-info","discourse/plugins/poll/discourse/components/poll-options","discourse/plugins/poll/discourse/components/poll-results-pie","discourse/plugins/poll/discourse/components/poll-results-tabs","@ember/component","@ember/template-factory"],(function(t,e,l,o,s,n,i,r,a,u,p,d,c,h,m,g,f,b,_,v,y,k,C){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
const w="staff_only",O="ranked_choice"
class x extends e.default{static#t=(()=>dt7948.g(this.prototype,"currentUser",[i.service]))()
#U=(()=>{dt7948.i(this,"currentUser")})()
static#l=(()=>dt7948.g(this.prototype,"siteSettings",[i.service]))()
#r=(()=>{dt7948.i(this,"siteSettings")})()
static#o=(()=>dt7948.g(this.prototype,"appEvents",[i.service]))()
#Y=(()=>{dt7948.i(this,"appEvents")})()
static#s=(()=>dt7948.g(this.prototype,"dialog",[i.service]))()
#e=(()=>{dt7948.i(this,"dialog")})()
static#n=(()=>dt7948.g(this.prototype,"router",[i.service]))()
#F=(()=>{dt7948.i(this,"router")})()
static#i=(()=>dt7948.g(this.prototype,"modal",[i.service]))()
#$=(()=>{dt7948.i(this,"modal")})()
static#h=(()=>dt7948.g(this.prototype,"isStaff",[l.tracked],(function(){return this.currentUser&&this.currentUser.staff})))()
#q=(()=>{dt7948.i(this,"isStaff")})()
static#m=(()=>dt7948.g(this.prototype,"vote",[l.tracked],(function(){return this.args.attrs.vote||[]})))()
#G=(()=>{dt7948.i(this,"vote")})()
static#g=(()=>dt7948.g(this.prototype,"titleHTML",[l.tracked],(function(){return(0,r.htmlSafe)(this.args.attrs.titleHTML)})))()
#K=(()=>{dt7948.i(this,"titleHTML")})()
static#f=(()=>dt7948.g(this.prototype,"topicArchived",[l.tracked],(function(){return this.args.attrs.post.get("topic.archived")})))()
#W=(()=>{dt7948.i(this,"topicArchived")})()
static#b=(()=>dt7948.g(this.prototype,"options",[l.tracked],(function(){return[]})))()
#z=(()=>{dt7948.i(this,"options")})()
static#_=(()=>dt7948.g(this.prototype,"poll",[l.tracked],(function(){return this.args.attrs.poll})))()
#Z=(()=>{dt7948.i(this,"poll")})()
static#v=(()=>dt7948.g(this.prototype,"voters",[l.tracked],(function(){return this.poll.voters||0})))()
#Q=(()=>{dt7948.i(this,"voters")})()
static#y=(()=>dt7948.g(this.prototype,"preloadedVoters",[l.tracked],(function(){return this.args.preloadedVoters||[]})))()
#J=(()=>{dt7948.i(this,"preloadedVoters")})()
static#k=(()=>dt7948.g(this.prototype,"isRankedChoice",[l.tracked],(function(){return this.poll.type===O})))()
#X=(()=>{dt7948.i(this,"isRankedChoice")})()
static#C=(()=>dt7948.g(this.prototype,"rankedChoiceOutcome",[l.tracked],(function(){return this.poll.ranked_choice_outcome||[]})))()
#tt=(()=>{dt7948.i(this,"rankedChoiceOutcome")})()
static#w=(()=>dt7948.g(this.prototype,"isMultiVoteType",[l.tracked],(function(){return this.isRankedChoice||this.isMultiple})))()
#et=(()=>{dt7948.i(this,"isMultiVoteType")})()
static#O=(()=>dt7948.g(this.prototype,"staffOnly",[l.tracked],(function(){return this.poll.results===w})))()
#lt=(()=>{dt7948.i(this,"staffOnly")})()
static#x=(()=>dt7948.g(this.prototype,"isMultiple",[l.tracked],(function(){return"multiple"===this.poll.type})))()
#ot=(()=>{dt7948.i(this,"isMultiple")})()
static#M=(()=>dt7948.g(this.prototype,"isNumber",[l.tracked],(function(){return"number"===this.poll.type})))()
#st=(()=>{dt7948.i(this,"isNumber")})()
static#T=(()=>dt7948.g(this.prototype,"showingResults",[l.tracked],(function(){return!1})))()
#nt=(()=>{dt7948.i(this,"showingResults")})()
static#R=(()=>dt7948.g(this.prototype,"hasSavedVote",[l.tracked],(function(){return this.args.attrs.hasSavedVote})))()
#it=(()=>{dt7948.i(this,"hasSavedVote")})()
static#S=(()=>dt7948.g(this.prototype,"status",[l.tracked],(function(){return this.poll.status})))()
#rt=(()=>{dt7948.i(this,"status")})()
static#P=(()=>dt7948.g(this.prototype,"showResults",[l.tracked],(function(){return this.hasSavedVote||this.showingResults||this.topicArchived&&!this.staffOnly||this.closed&&!this.staffOnly})))()
#at=(()=>{dt7948.i(this,"showResults")})()
post=this.args.attrs.post
isMe=(()=>this.currentUser&&this.args.attrs.post.user_id===this.currentUser.id)()
checkUserGroups=(t,e)=>{const l=e&&e.groups&&e.groups.split(",").map((t=>t.toLowerCase()))
if(!l)return!0
const o=t&&t.groups&&t.groups.map((t=>t.name.toLowerCase()))
return o&&l.some((t=>o.includes(t)))}
castVotes=t=>{if(this.canCastVotes&&this.currentUser)return(0,a.ajax)("/polls/vote",{type:"PUT",data:{post_id:this.args.attrs.post.id,poll_name:this.poll.name,options:this.vote}}).then((t=>{let{poll:e}=t
this.options=[...e.options],this.hasSavedVote=!0,this.rankedChoiceOutcome=e.ranked_choice_outcome||[],this.poll.setProperties(e),this.appEvents.trigger("poll:voted",e,this.args.attrs.post,this.args.attrs.vote)
const l=e.voters
this.voters=Number(l),"on_close"!==this.poll.results&&(this.showResults=!0),"staff_only"===this.poll.results&&(this.currentUser&&this.currentUser.staff?this.showResults=!0:this.showResults=!1)})).catch((e=>{e?(this.isMultiple||this.isRankedChoice||this._toggleOption(t),(0,u.popupAjaxError)(e)):this.dialog.alert(h.default.t("poll.error_while_casting_votes"))}))}
areRanksValid=t=>{let e=new Set,l=!1
return t.forEach((t=>{const o=t.rank
if(0!==o){if(e.has(o))return void(l=!0)
e.add(o)}})),!l}
_toggleOption=(()=>{var t=this
return function(e){let l=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,o=t.options,s=t.vote
if(t.isMultiple){const t=s.indexOf(e.id);-1!==t?s.splice(t,1):s.push(e.id)}else t.isRankedChoice?o.forEach(((t,n)=>{const i=s.findIndex((e=>e.digest===t.id));-1===i?s.push({digest:t.id,rank:t.id===e?l:0}):t.id===e&&(s[i].rank=l,o[n].rank=l)})):s=[e.id]
t.vote=[...s],t.options=[...o]}})()
constructor(){super(...arguments),this.id=this.args.attrs.id,this.post=this.args.attrs.post,this.options=this.poll.options,this.groupableUserFields=this.args.attrs.groupableUserFields,this.rankedChoiceDropdownContent=[],this.isRankedChoice&&this.rankedChoiceDropdownContent.push({id:0,name:h.default.t("poll.options.ranked_choice.abstain")}),this.options.forEach(((t,e)=>{t.rank=0,this.isRankedChoice&&(this.rankedChoiceDropdownContent.push({id:e+1,name:(e+1).toString()}),this.args.attrs.vote.forEach((e=>{e.digest===t.id&&(t.rank=e.rank)})))}))}get min(){let t=parseInt(this.args.attrs.poll.min,10)
return(isNaN(t)||t<0)&&(t=1),t}get max(){let t=parseInt(this.args.attrs.poll.max,10)
const e=this.args.attrs.poll.options.length
return(isNaN(t)||t>e)&&(t=e),t}get closed(){return"closed"===this.status||this.isAutomaticallyClosed}get isAutomaticallyClosed(){const t=this.poll
return(t.close??!1)&&moment.utc(t.close,"YYYY-MM-DD HH:mm:ss Z")<=moment()}get hasVoted(){return this.vote&&this.vote.length>0}get hideResultsDisabled(){return!this.staffOnly&&(this.closed||this.topicArchived)}toggleOption(t){let e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0
if(!this.closed&&this.currentUser&&this.checkUserGroups(this.currentUser,this.poll)){if(!this.isMultiple&&!this.isRankedChoice&&1===this.vote.length&&this.vote[0]===t.id)return this.removeVote()
this.isMultiple||this.isRankedChoice||(this.vote.length=0),this._toggleOption(t,e),this.isMultiple||this.isRankedChoice||this.castVotes(t)}}static#V=(()=>dt7948.n(this.prototype,"toggleOption",[s.action]))()
toggleResults(){const t=!this.showResults
this.showResults=t}static#j=(()=>dt7948.n(this.prototype,"toggleResults",[s.action]))()
get canCastVotes(){if(this.closed||this.showingResults||!this.currentUser)return!1
const t=this.vote?.length||0
return this.isMultiple?t>=this.min&&t<=this.max:this.isRankedChoice?this.options.length===this.vote.length&&this.areRanksValid(this.vote):t>0}get notInVotingGroup(){return!this.checkUserGroups(this.currentUser,this.poll)}get pollGroups(){return h.default.t("poll.results.groups.title",{groups:this.poll.groups})}get showCastVotesButton(){return(this.isMultiple||this.isRankedChoice)&&!this.showResults}get castVotesButtonClass(){return"btn cast-votes "+(this.canCastVotes?"btn-primary":"btn-default")}get castVotesButtonIcon(){return this.castVotesDisabled?"far-square":"check"}get castVotesDisabled(){return!this.canCastVotes}get showHideResultsButton(){return this.showResults&&!this.hideResultsDisabled}get showShowResultsButton(){return!(this.showResults||this.hideResultsDisabled||"on_vote"===this.poll.results&&!this.hasSavedVote&&!this.isMe||"on_close"===this.poll.results&&!this.closed||this.poll.results===w&&!this.isStaff||!(this.voters>0))}get showRemoveVoteButton(){return!this.showResults&&!this.closed&&!this.hideResultsDisabled&&this.hasSavedVote}get isCheckbox(){return!!this.isMultiple}get resultsWidgetTypeClass(){const t=this.poll.type
return this.isNumber||this.poll.chart_type!==g.PIE_CHART_TYPE?`discourse-poll-${t}-results`:"discourse-poll-pie-chart"}get resultsPie(){return this.poll.chart_type===g.PIE_CHART_TYPE}get averageRating(){const t=this.options.reduce(((t,e)=>t+parseInt(e.html,10)*parseInt(e.votes,10)),0),e=0===this.voters?0:(0,p.default)(t/this.voters,-2)
return(0,r.htmlSafe)(h.default.t("poll.average_rating",{average:e}))}updatedVoters(){this.preloadedVoters=this.args.preloadedVoters,this.options=[...this.args.options],this.isRankedChoice&&this.options.forEach((t=>{let e=this.vote.find((e=>e.digest===t.id)),l=e?e.rank:0
t.rank=l}))}static#E=(()=>dt7948.n(this.prototype,"updatedVoters",[s.action]))()
fetchVoters(t){let e
this.loading=!0
let l=this.options
return l.find((e=>e.id===t)).loading=!0,this.options=[...l],e=this.options.find((e=>e.id===t)).votes,(0,a.ajax)("/polls/voters.json",{data:{post_id:this.post.id,poll_name:this.poll.name,option_id:t,page:Math.floor(e/25)+1,limit:25}}).then((e=>{const l=t?this.preloadedVoters[t]:this.preloadedVoters,o=t?e.voters[t]:e.voters
if(this.isRankedChoice)this.preloadedVoters[t]=[...new Set([...o])]
else{const e=new Set(l.map((t=>t.username)))
o.forEach((t=>{e.has(t.username)||(e.add(t.username),l.push(t))})),"regular"===this.poll.type&&Object.keys(this.preloadedVoters).forEach((l=>{t!==l&&(this.preloadedVoters[l]=this.preloadedVoters[l].filter((t=>!e.has(t.username))))}))}this.preloadedVoters[t]=[...new Set([...this.preloadedVoters[t],...o])]})).catch((t=>{t?(0,u.popupAjaxError)(t):this.dialog.alert(h.default.t("poll.error_while_fetching_voters"))})).finally((()=>{l.find((e=>e.id===t)).loading=!1,this.options=[...l]}))}static#N=(()=>dt7948.n(this.prototype,"fetchVoters",[s.action]))()
dropDownClick(t){this[t]()}static#A=(()=>dt7948.n(this.prototype,"dropDownClick",[s.action]))()
removeVote(){return(0,a.ajax)("/polls/vote",{type:"DELETE",data:{post_id:this.post.id,poll_name:this.poll.name}}).then((t=>{let{poll:e}=t
this.poll.type===O&&e.options.forEach((t=>{t.rank=0})),this.options=[...e.options],this.poll.setProperties(e),this.rankedChoiceOutcome=e.ranked_choice_outcome||[],this.vote=[],this.voters=e.voters,this.hasSavedVote=!1,this.appEvents.trigger("poll:voted",e,this.post,this.vote)})).catch((t=>(0,u.popupAjaxError)(t)))}static#ut=(()=>dt7948.n(this.prototype,"removeVote",[s.action]))()
toggleStatus(){this.isAutomaticallyClosed||this.dialog.yesNoConfirm({message:h.default.t(this.closed?"poll.open.confirm":"poll.close.confirm"),didConfirm:()=>{const t=this.closed?"open":"closed";(0,a.ajax)("/polls/toggle_status",{type:"PUT",data:{post_id:this.post.id,poll_name:this.poll.name,status:t}}).then((()=>{this.poll.status=t,this.status=t,"on_close"!==this.poll.results&&"always"!==this.poll.results||(this.showResults="closed"===this.status)})).catch((t=>{t?(0,u.popupAjaxError)(t):this.dialog.alert(h.default.t("poll.error_while_toggling_status"))}))}})}static#pt=(()=>dt7948.n(this.prototype,"toggleStatus",[s.action]))()
showBreakdown(){this.modal.show(m.default,{model:this.args.attrs})}static#dt=(()=>dt7948.n(this.prototype,"showBreakdown",[s.action]))()
exportResults(){const t=this.poll.type===O?this.siteSettings.poll_export_ranked_choice_data_explorer_query_id:this.siteSettings.poll_export_data_explorer_query_id;(0,a.ajax)(`/admin/plugins/explorer/queries/${t}/run.csv`,{type:"POST",data:{params:JSON.stringify({poll_name:this.poll.name,post_id:this.post.id.toString()}),explain:!1,limit:1e6,download:1}}).then((t=>{const e=document.createElement("a"),l=new Blob([t],{type:"text/csv;charset=utf-8;"})
e.href=URL.createObjectURL(l),e.setAttribute("download",`poll-export-${this.poll.name}-${this.post.id}.csv`),e.click(),e.remove()})).catch((t=>{t?(0,u.popupAjaxError)(t):this.dialog.alert(h.default.t("poll.error_while_exporting_results"))}))}static#ct=(()=>dt7948.n(this.prototype,"exportResults",[s.action]))()
static#ht=(()=>(0,k.setComponentTemplate)((0,C.createTemplateFactory)({id:"Hgu9Egrt",block:'[[[1,"\\n    "],[11,0],[24,0,"poll-container"],[4,[32,0],[[30,0,["updatedVoters"]],[30,1]],null],[12],[1,"\\n      "],[1,[30,0,["titleHTML"]]],[1,"\\n"],[41,[30,0,["notInVotingGroup"]],[[[1,"        "],[10,0],[14,0,"alert alert-danger"],[12],[1,[30,0,["pollGroups"]]],[13],[1,"\\n"]],[]],null],[41,[30,0,["showResults"]],[[[1,"        "],[10,0],[15,0,[30,0,["resultsWidgetTypeClass"]]],[12],[1,"\\n"],[41,[30,0,["isNumber"]],[[[1,"            "],[10,1],[12],[1,[30,0,["averageRating"]]],[13],[1,"\\n"]],[]],[[[41,[30,0,["resultsPie"]],[[[1,"              "],[8,[32,1],null,[["@id","@options"],[[30,0,["id"]],[30,0,["options"]]]],null],[1,"\\n"]],[]],[[[1,"              "],[8,[32,2],null,[["@options","@pollName","@pollType","@isRankedChoice","@isPublic","@postId","@vote","@voters","@votersCount","@fetchVoters","@rankedChoiceOutcome"],[[30,0,["options"]],[30,0,["poll","name"]],[30,0,["poll","type"]],[30,0,["isRankedChoice"]],[30,0,["poll","public"]],[30,0,["post","id"]],[30,0,["vote"]],[30,0,["preloadedVoters"]],[30,0,["poll","voters"]],[30,0,["fetchVoters"]],[30,0,["rankedChoiceOutcome"]]]],null],[1,"\\n"]],[]]]],[]]],[1,"        "],[13],[1,"\\n"]],[]],[[[1,"        "],[8,[32,3],null,[["@isCheckbox","@isRankedChoice","@rankedChoiceDropdownContent","@options","@votes","@sendOptionSelect"],[[30,0,["isCheckbox"]],[30,0,["isRankedChoice"]],[30,0,["rankedChoiceDropdownContent"]],[30,0,["options"]],[30,0,["vote"]],[30,0,["toggleOption"]]]],null],[1,"\\n"]],[]]],[1,"    "],[13],[1,"\\n    "],[8,[32,4],null,[["@options","@min","@max","@isMultiple","@close","@closed","@results","@showResults","@postUserId","@isPublic","@hasVoted","@voters"],[[30,0,["options"]],[30,0,["min"]],[30,0,["max"]],[30,0,["isMultiple"]],[30,0,["close"]],[30,0,["closed"]],[30,0,["poll","results"]],[30,0,["showResults"]],[30,0,["poll","post","user_id"]],[30,0,["poll","public"]],[30,0,["hasVoted"]],[30,0,["voters"]]]],null],[1,"\\n    "],[10,0],[14,0,"poll-buttons"],[12],[1,"\\n"],[41,[30,0,["showCastVotesButton"]],[[[1,"        "],[11,"button"],[16,0,[30,0,["castVotesButtonClass"]]],[24,"title","poll.cast-votes.title"],[16,"disabled",[30,0,["castVotesDisabled"]]],[4,[32,5],["click",[30,0,["castVotes"]]],null],[12],[1,"\\n          "],[1,[28,[32,6],[[30,0,["castVotesButtonIcon"]]],null]],[1,"\\n          "],[10,1],[14,0,"d-button-label"],[12],[1,[28,[32,7],["poll.cast-votes.label"],null]],[13],[1,"\\n        "],[13],[1,"\\n"]],[]],null],[1,"\\n"],[41,[30,0,["showHideResultsButton"]],[[[1,"        "],[11,"button"],[24,0,"btn btn-default toggle-results"],[24,"title","poll.hide-results.title"],[4,[32,5],["click",[30,0,["toggleResults"]]],null],[12],[1,"\\n          "],[1,[28,[32,6],["chevron-left"],null]],[1,"\\n          "],[10,1],[14,0,"d-button-label"],[12],[1,[28,[32,7],["poll.hide-results.label"],null]],[13],[1,"\\n        "],[13],[1,"\\n"]],[]],null],[1,"\\n"],[41,[30,0,["showShowResultsButton"]],[[[1,"        "],[11,"button"],[24,0,"btn btn-default toggle-results"],[24,"title","poll.show-results.title"],[4,[32,5],["click",[30,0,["toggleResults"]]],null],[12],[1,"\\n          "],[1,[28,[32,6],["chart-bar"],null]],[1,"\\n          "],[10,1],[14,0,"d-button-label"],[12],[1,[28,[32,7],["poll.show-results.label"],null]],[13],[1,"\\n        "],[13],[1,"\\n"]],[]],null],[1,"\\n"],[41,[30,0,["showRemoveVoteButton"]],[[[1,"        "],[11,"button"],[24,0,"btn btn-default remove-vote"],[24,"title","poll.remove-vote.title"],[4,[32,5],["click",[30,0,["removeVote"]]],null],[12],[1,"\\n          "],[1,[28,[32,6],["undo"],null]],[1,"\\n          "],[10,1],[14,0,"d-button-label"],[12],[1,[28,[32,7],["poll.remove-vote.label"],null]],[13],[1,"\\n        "],[13],[1,"\\n"]],[]],null],[1,"\\n      "],[8,[32,8],null,[["@closed","@voters","@isStaff","@isMe","@isRankedChoice","@topicArchived","@groupableUserFields","@isAutomaticallyClosed","@dropDownClick"],[[30,0,["closed"]],[30,0,["voters"]],[30,0,["isStaff"]],[30,0,["isMe"]],[30,0,["isRankedChoice"]],[30,0,["topicArchived"]],[30,0,["groupableUserFields"]],[30,0,["isAutomaticallyClosed"]],[30,0,["dropDownClick"]]]],null],[1,"\\n    "],[13],[1,"\\n  "]],["@preloadedVoters"],false,["if"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/components/poll.js",scope:()=>[n.default,v.default,y.default,_.default,b.default,o.on,d.default,c.default,f.default],isStrictMode:!0}),this))()}t.default=x})),define("discourse/plugins/poll/discourse/initializers/add-poll-ui-builder",["exports","discourse/lib/plugin-api","discourse/plugins/poll/discourse/components/modal/poll-ui-builder"],(function(t,e,l){"use strict"
function o(t){t.addComposerToolbarPopupMenuOption({action:e=>{t.container.lookup("service:modal").show(l.default,{model:{toolbarEvent:e}})},icon:"chart-bar",label:"poll.ui_builder.title",condition:e=>{const l=t.container.lookup("service:site-settings"),o=t.getCurrentUser()
return l.poll_enabled&&(e.model.topic?.pm_with_non_human_user||o&&(o.staff||o.can_create_poll))}})}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
t.default={name:"add-poll-ui-builder",initialize(){(0,e.withPluginApi)("1.14.0",o)}}})),define("discourse/plugins/poll/discourse/initializers/extend-for-poll",["exports","@ember/object","discourse/lib/plugin-api","discourse/widgets/glue","discourse-common/lib/get-owner","discourse-common/utils/decorators"],(function(t,e,l,o,s,n){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
const i="discourse-poll"
let r=[],a=null
function u(){r.forEach((t=>t.queueRerender()))}function p(){a&&(clearInterval(a),a=null),r.forEach((t=>t.cleanUp())),r=[]}function d(t){const l=(0,s.getRegister)(t),d=t.container.lookup("service:site-settings").poll_groupable_user_fields
p(),t.modifyClass("controller:topic",dt7948.p({pluginId:i,subscribe(){this._super(...arguments),this.messageBus.subscribe(`/polls/${this.model.id}`,this._onPollMessage)},unsubscribe(){this.messageBus.unsubscribe("/polls/*",this._onPollMessage),this._super(...arguments)},_onPollMessage(t){const e=this.get("model.postStream").findLoadedPost(t.post_id)
e?.set("polls",t.polls)}},[["method","_onPollMessage",[n.bind]]])),t.modifyClass("model:post",dt7948.p({pluginId:i,_polls:null,pollsObject:null,pollsChanged(){const t=this.polls
t&&(this._polls=this._polls||{},t.forEach((t=>{this._polls[t.name]?this._polls[t.name].setProperties(t):this._polls[t.name]=e.default.create(t)})),this.set("pollsObject",this._polls),u())}},[["method","pollsChanged",[(0,n.observes)("polls")]]])),t.includePostAttributes("polls","polls_votes"),t.decorateCookedElement((function(s,n){let i=[...s.querySelectorAll(".poll")]
if(i=i.filter((t=>"BLOCKQUOTE"!==t.parentNode.tagName)),!i.length||!n)return
const p=n.getModel()
t.preventCloak(p.id),p.pollsChanged()
const c=p.pollsObject||{},h=p.polls_votes||{}
a=a||setInterval(u,3e4),i.forEach((t=>{const s=t.dataset.pollName
let i=c[s],a=p,u=h[s]||[]
const m=t.closest(".expanded-quote")?.dataset.postId
if(m&&p.quoted[m]&&(a=p.quoted[m],a=e.default.create(a),i=e.default.create(a.polls.findBy("name",s)),u=a.polls_votes||{},u=u[s]||[]),i){const e=t.querySelector(".poll-title"),p={id:`${s}-${a.id}`,post:a,poll:i,vote:u,hasSavedVote:u.length>0,titleHTML:e?.outerHTML,groupableUserFields:(d||"").split("|").filter(Boolean),_postCookedWidget:n.widget},c=new o.default("discourse-poll",l,p)
c.appendTo(t),r.push(c)}}))}),{onlyStream:!0}),t.cleanupStream(p)
t.container.lookup("service:site-settings").poll_enabled&&t.addSearchSuggestion("in:polls")}t.default={name:"extend-for-poll",initialize(){(0,l.withPluginApi)("0.8.7",d)}}})),define("discourse/plugins/poll/discourse/widgets/discourse-poll",["exports","discourse/widgets/render-glimmer","discourse/widgets/widget","discourse/plugins/poll/discourse/components/modal/poll-ui-builder","@ember/template-factory"],(function(t,e,l,o,s){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0
t.default=(0,l.createWidget)("discourse-poll",{tagName:"div",buildKey:t=>`poll-${t.id}`,services:["dialog"],buildAttributes(t){let e="poll-outer"
return t.poll.chart_type===o.PIE_CHART_TYPE&&(e+=" pie"),{class:e,"data-poll-name":t.poll.name,"data-poll-type":t.poll.type}},html(t){return[new e.default(this,"div.poll",(0,s.createTemplateFactory)({id:"p7rCUspl",block:'[[[8,[39,0],null,[["@attrs","@preloadedVoters","@options"],[[30,1,["attrs"]],[30,1,["preloadedVoters"]],[30,1,["options"]]]],null]],["@data"],false,["poll"]]',moduleName:"/discourse/app/assets/javascripts/discourse/discourse/plugins/poll/discourse/widgets/discourse-poll.js",isStrictMode:!1}),{attrs:t,preloadedVoters:t.poll.preloaded_voters,options:t.poll.options})]}})})),define("discourse/plugins/poll/lib/chart-colors",["exports"],(function(t){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.getColors=function(t,e){let l
switch(e=e||"cool"){case"cool":l={0:[255,255,255],25:[220,237,200],50:[66,179,213],75:[26,39,62],100:[0,0,0]}
break
case"warm":l={0:[255,255,255],25:[254,235,101],50:[228,82,27],75:[77,52,47],100:[0,0,0]}}let o,s,n=Object.keys(l),i=[]
for(let r=0;r<t;r++){let e
o=(r+1)*(100/(t+1)),s=s||0
for(let t=s;t<n.length;t++){if(!n[t+1]){e=t-1
break}if(o>=n[t]&&o<n[t+1]){e=t
break}}let a=(o-n[e])/(n[e+1]-n[e]),u=[]
for(let t=0;t<3;t++)u.push(Math.round(l[n[e]][t]-(l[n[e]][t]-l[n[e+1]][t])*a))
i.push(`rgb(${u.toString()})`),s=e}return i}})),define("discourse/plugins/poll/lib/discourse-markdown/poll",["exports","discourse-i18n"],(function(t,e){"use strict"
Object.defineProperty(t,"__esModule",{value:!0}),t.setup=function(t){t.allowList(["a.button.cast-votes","a.button.toggle-results","div.poll-buttons","div.poll-container","div.poll-info_counts-count","div.poll-info_counts","div.poll-info","div.poll-title","div.poll","div[data-*]","li[data-*]","span.info-label","span.info-number","span.info-text"]),t.registerOptions(((t,e)=>{t.features.poll=e.poll_enabled,t.pollMaximumOptions=e.poll_maximum_options})),t.registerPlugin((t=>t.block.bbcode.ruler.push("poll",i)))}
/*!
   * Joseph Myer's md5() algorithm wrapped in a self-invoked function to prevent
   * global namespace pollution, modified to hash unicode characters as UTF-8.
   *
   * Copyright 1999-2010, Joseph Myers, Paul Johnston, Greg Holt, Will Bond <will@wbond.net>
   * http://www.myersdaily.org/joseph/javascript/md5-text.html
   * http://pajhome.org.uk/crypt/md5
   *
   * Released under the BSD license
   * http://www.opensource.org/licenses/bsd-license
   */
const l="data-poll-",o={name:"poll",status:"open"},s=["chartType","close","groups","max","min","name","order","public","results","status","step","type"]
function n(t,e,o){let s=t.push("poll_container_open","div",1)
s.attrs=[["class","poll-container"]],e.length>0&&(s=t.push("poll_title_open","div",1),s.attrs=[["class","poll-title"]],t.tokens.push(...e),t.push("poll_title_close","div",-1))
for(let n=0;n<o.length;n++)if("list_item_open"===o[n].type){let t=o.findIndex(((t,e)=>e>n&&"list_item_close"===t.type))
if(-1===t)continue
let e=o.slice(n,t+1).filter((t=>"text"===t.type||"inline"===t.type)).map((t=>t.content)).join(" "),s=function(t){for(let e=0;e<t.length;e++)t[e]=g(t[e])
return t.join("")}(function(t){t=unescape(encodeURI(t))
let e,l=t.length,o=[1732584193,-271733879,-1732584194,271733878]
for(e=64;e<=t.length;e+=64)r(o,h(t.substring(e-64,e)))
t=t.substring(e-64)
let s=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
for(e=0;e<t.length;e++)s[e>>2]|=t.charCodeAt(e)<<(e%4<<3)
if(s[e>>2]|=128<<(e%4<<3),e>55)for(r(o,s),e=0;e<16;e++)s[e]=0
return s[14]=8*l,r(o,s),o}(JSON.stringify([e])))
o[n].attrs||=[],o[n].attrs.push([l+"option-id",s])}t.tokens.push(...o),t.push("poll_container_close","div",-1)}const i={tag:"poll",before(t,e){let{attrs:l}=e
t.tokens.filter((t=>"poll_open"===t.type)).length>t.tokens.filter((t=>"poll_close"===t.type)).length||(t.push("poll_open","div",1).poll_attrs={...o,...l})},after(t,o){if("poll_open"!==o.type)return
let i=o.poll_attrs,r=t.tokens.indexOf(o),a=t.tokens.slice(r+1),u=[]
if(a.length>0&&"heading_open"===a[0].type){let e=a.findIndex((t=>"heading_close"===t.type));-1!==e&&(u=a.splice(0,e+1).slice(1,-1),t.tokens.splice(r+1,e+1))}if("number"===i.type){let e=parseInt(i.min,10),l=parseInt(i.max,10),o=parseInt(i.step,10)
if(isNaN(e)&&(e=1),isNaN(l)&&(l=t.md.options.discourse.pollMaximumOptions),(isNaN(o)||o<1)&&(o=1),a.length>0)return void t.tokens.splice(r,1)
e<=l&&function(t,e,l,o,s){e.push(new t.Token("bullet_list_open","ul",1))
for(let n=l;n<=o;n+=s){e.push(new t.Token("list_item_open","li",1))
let l=new t.Token("text","",0)
l.content=String(n),e.push(l),e.push(new t.Token("list_item_close","li",-1))}e.push(new t.Token("bullet_list_close","ul",-1))}(t,a,e,l,o)}t.tokens.splice(r+1),o.attrs||=[],o.attrs.push(["class","poll"])
for(let e of s)i[e]&&o.attrs.push([l+e,i[e]])
a.length>0&&!a[0].type.endsWith("_list_open")||(n(t,u,a),function(t){let l=t.push("poll_info_open","div",1)
l.attrs=[["class","poll-info"]],l=t.push("poll_info_counts_open","div",1),l.attrs=[["class","poll-info_counts"]],l=t.push("poll_info_counts_count_open","div",1),l.attrs=[["class","poll-info_counts-count"]],l=t.push("poll_info_number_open","span",1),l.attrs=[["class","info-number"]],l.block=!1,l=t.push("text","",0),l.content="0",t.push("poll_info_number_close","span",-1),l=t.push("poll_info_label_open","span",1),l.attrs=[["class","info-label"]],l.block=!1,l=t.push("text","",0),l.content=e.default.t("poll.voters",{count:0}),t.push("poll_info_label_close","span",-1),t.push("poll_info_counts_count_close","div",-1),t.push("poll_info_counts_close","div",-1),t.push("poll_info_close","div",-1)}(t),t.push("poll_close","div",-1))}}
function r(t,e){let l=t[0],o=t[1],s=t[2],n=t[3]
l=u(l,o,s,n,e[0],7,-680876936),n=u(n,l,o,s,e[1],12,-389564586),s=u(s,n,l,o,e[2],17,606105819),o=u(o,s,n,l,e[3],22,-1044525330),l=u(l,o,s,n,e[4],7,-176418897),n=u(n,l,o,s,e[5],12,1200080426),s=u(s,n,l,o,e[6],17,-1473231341),o=u(o,s,n,l,e[7],22,-45705983),l=u(l,o,s,n,e[8],7,1770035416),n=u(n,l,o,s,e[9],12,-1958414417),s=u(s,n,l,o,e[10],17,-42063),o=u(o,s,n,l,e[11],22,-1990404162),l=u(l,o,s,n,e[12],7,1804603682),n=u(n,l,o,s,e[13],12,-40341101),s=u(s,n,l,o,e[14],17,-1502002290),o=u(o,s,n,l,e[15],22,1236535329),l=p(l,o,s,n,e[1],5,-165796510),n=p(n,l,o,s,e[6],9,-1069501632),s=p(s,n,l,o,e[11],14,643717713),o=p(o,s,n,l,e[0],20,-373897302),l=p(l,o,s,n,e[5],5,-701558691),n=p(n,l,o,s,e[10],9,38016083),s=p(s,n,l,o,e[15],14,-660478335),o=p(o,s,n,l,e[4],20,-405537848),l=p(l,o,s,n,e[9],5,568446438),n=p(n,l,o,s,e[14],9,-1019803690),s=p(s,n,l,o,e[3],14,-187363961),o=p(o,s,n,l,e[8],20,1163531501),l=p(l,o,s,n,e[13],5,-1444681467),n=p(n,l,o,s,e[2],9,-51403784)
s=p(s,n,l,o,e[7],14,1735328473),o=p(o,s,n,l,e[12],20,-1926607734),l=d(l,o,s,n,e[5],4,-378558),n=d(n,l,o,s,e[8],11,-2022574463),s=d(s,n,l,o,e[11],16,1839030562),o=d(o,s,n,l,e[14],23,-35309556),l=d(l,o,s,n,e[1],4,-1530992060),n=d(n,l,o,s,e[4],11,1272893353),s=d(s,n,l,o,e[7],16,-155497632),o=d(o,s,n,l,e[10],23,-1094730640),l=d(l,o,s,n,e[13],4,681279174),n=d(n,l,o,s,e[0],11,-358537222),s=d(s,n,l,o,e[3],16,-722521979),o=d(o,s,n,l,e[6],23,76029189),l=d(l,o,s,n,e[9],4,-640364487),n=d(n,l,o,s,e[12],11,-421815835),s=d(s,n,l,o,e[15],16,530742520),o=d(o,s,n,l,e[2],23,-995338651),l=c(l,o,s,n,e[0],6,-198630844),n=c(n,l,o,s,e[7],10,1126891415),s=c(s,n,l,o,e[14],15,-1416354905),o=c(o,s,n,l,e[5],21,-57434055),l=c(l,o,s,n,e[12],6,1700485571),n=c(n,l,o,s,e[3],10,-1894986606),s=c(s,n,l,o,e[10],15,-1051523),o=c(o,s,n,l,e[1],21,-2054922799),l=c(l,o,s,n,e[8],6,1873313359),n=c(n,l,o,s,e[15],10,-30611744),s=c(s,n,l,o,e[6],15,-1560198380),o=c(o,s,n,l,e[13],21,1309151649)
l=c(l,o,s,n,e[4],6,-145523070),n=c(n,l,o,s,e[11],10,-1120210379),s=c(s,n,l,o,e[2],15,718787259),o=c(o,s,n,l,e[9],21,-343485551),t[0]=f(l,t[0]),t[1]=f(o,t[1]),t[2]=f(s,t[2]),t[3]=f(n,t[3])}function a(t,e,l,o,s,n){return e=f(f(e,t),f(o,n)),f(e<<s|e>>>32-s,l)}function u(t,e,l,o,s,n,i){return a(e&l|~e&o,t,e,s,n,i)}function p(t,e,l,o,s,n,i){return a(e&o|l&~o,t,e,s,n,i)}function d(t,e,l,o,s,n,i){return a(e^l^o,t,e,s,n,i)}function c(t,e,l,o,s,n,i){return a(l^(e|~o),t,e,s,n,i)}function h(t){let e,l=[]
for(e=0;e<64;e+=4)l[e>>2]=t.charCodeAt(e)+(t.charCodeAt(e+1)<<8)+(t.charCodeAt(e+2)<<16)+(t.charCodeAt(e+3)<<24)
return l}let m="0123456789abcdef".split("")
function g(t){let e="",l=0
for(;l<4;l++)e+=m[t>>8*l+4&15]+m[t>>8*l&15]
return e}function f(t,e){return t+e&4294967295}})),define("discourse/plugins/poll/lib/even-round",["exports"],(function(t){"use strict"
function e(t){return 100===t.map((t=>Math.floor(t))).reduce(((t,e)=>t+e))}Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(t){let l=t.map((t=>t%1))
const o=Math.ceil(l.reduce(((t,e)=>t+e)))
for(let s=0,n=l.length;s<o&&s<n;s++){let o=0,s=0
for(let t=0;t<l.length;t++)l[t]>o&&(s=t,o=l[t])
if(++t[s],l[s]=0,e(t))break}return t.map((t=>Math.floor(t)))}}))

//# sourceMappingURL=poll-7cfbb6555e675ae12f1f21669a5e465ca57f05e5dc0e284eb775a44550e41d4a.map
//!

;
